<style type="text/css">
pre {
	font-size:14px;
	border: 1px solid #999;
	padding: 20px;
	white-space: pre-wrap;
	word-wrap: break-word;
	background-color: #FFF;
}
.red {color:red;}
</style>


<h2>Récupération des données</h2>
<p>Pour récupérer les données, il faut passer par le hook 'spxdatas::getData'. Il n'y a qu'un hook et un seul pour cette version.</p>
<p>Note : Coté client le plugin autorise juste a faire un get des données. <strong>On ne peut pas enregistrer des entrées coté client pour le moment</strong>.</p>
<p>1) Exemple simple</p>
<p>Par exemple ici on récupère les liens sous forme de liste html. Le #name de la colonne de la table est remplacé par la valeur des différentes entrées.</p>
<pre>
&lt;?php
global $plxShow;
$o= array();<br />$o[&quot;table&quot;]=&quot;<span class="red">link</span>&quot;;
$o[&quot;out&quot;]=&quot;html&quot;;
$o[&quot;format&quot;]='&lt;li&gt;&lt;a href=&quot;<span class="red">#url</span>&quot; title=&quot;<span class="red">#description</span>&quot;&gt;<span class="red">#name</span>&lt;/a&gt;&lt;/li&gt;';<br />
echo (&quot;&lt;u1&gt;&quot;.<span class="red">$plxShow-&gt;callHook('spxdatas::getData',$o)</span>.&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<p>Exemple 2 : On filtre la liste en ne prenant que les entrées dont les champs actif=1 (true)</p>
<pre>&lt;?php
global $plxShow;
$o= array();<br />$o[&quot;table&quot;]=&quot;portfolio&quot;;
$o[&quot;filter&quot;]=&quot;<span class="red">actif=1</span>&quot;;
$o[&quot;out&quot;]=&quot;html&quot;;
$o[&quot;format&quot;]='&lt;li&gt;&lt;a href=&quot;#liens&quot; title=&quot;#description&quot;&gt;#nom&lt;/a&gt;&lt;/li&gt;';<br />
echo (&quot;&lt;u1&gt;&quot;.<span class="red">$plxShow-&gt;callHook('spxdatas::getData',$o)</span>.&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<p>Exemple 3 : On filtre la liste en ne prenant que les entrées dont les champs actif=1 (true) et dont la category=001</p>
<pre>&lt;?php
global $plxShow;
$o= array();<br />$o[&quot;table&quot;]=&quot;portfolio&quot;;
$o[&quot;filter&quot;]=&quot;<span class="red">actif=1 and category=001</span>&quot;;
$o[&quot;out&quot;]=&quot;html&quot;;
$o[&quot;format&quot;]='formatage html';
<br />echo (&quot;&lt;u1&gt;&quot;.$plxShow-&gt;callHook('spxdatas::getData',$o).&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<p>Exemple 4 : Récupération uniquement d'une entrée avec un id d'une table précise. Dans ce cas la c'est particulier, il suffit juste de donner dans le filter le nom dela table et de rajouter _id</p>
<p>exemple : pour la table &quot;link&quot; le filter devient <span class="red">link_id</span>=id</p>
<pre>
&lt;?php
global $plxShow;
$o= array();<br />$o[&quot;table&quot;]=&quot;portfolio&quot;;
$o[&quot;filter&quot;]=&quot;<span class="red">portfolio_id=001</span>&quot;;
$o[&quot;out&quot;]=&quot;html&quot;;
$o[&quot;format&quot;]='formatage html';
<br />echo (&quot;&lt;u1&gt;&quot;.$plxShow-&gt;callHook('spxdatas::getData',$o).&quot;&lt;/u1&gt;&quot;);
?&gt;
</pre>
<h3>2) Liste des paramètres</h3>
<p>Voici la liste complète des paramètres de recherche.</p>
<pre>&lt;?php
global $plxShow;
$o= array();

// <strong>table</strong> : nom de la table pour laquelle on veux récupérer les entrées (<span class="red">obligatoire</span>)<br />$o[&quot;table&quot;]=&quot;portfolio&quot;;
<strong>
// filter</strong> : filtre a appliquer sur les résultats de la forme &quot;table.field1=valeur and table.field2=valeur2 and...&quot;
$o[&quot;filter&quot;]=&quot;<span class="red">actif=1</span>&quot;;

// <strong>order</strong> : ordre de récupération des résultats par le nom d'une colonne de table. D pour ascendant D pour descendant. Par default order ascendant.
$o[&quot;order&quot;]=&quot;title|A&quot;;

<br />// <strong>limit</strong> : limite le nombre d'élément dans la sortie (max a 10 ici)<br />$o[&quot;limit&quot;]=10;<br />
// <strong>offset</strong> : commence à offset 5 (pour paginer de 5 en 5 par exemple)<br />$o[&quot;offset&quot;]=5;<br />
// <strong>out</strong> : output de sortie on a la possibilité array, array_html, html, array_asso (<span class="red">default html</span>)
// note : array_asso permet de faire une sortie de type $a[$id_record]<br />$o[&quot;out&quot;]=&quot;html&quot;;

// précise le formatage html #name est remplacé par la valeur<br />$o[&quot;format&quot;]='&lt;li&gt;&lt;a href=&quot;#liens&quot; title=&quot;#description&quot;&gt;#nom&lt;/a&gt;&lt;/li&gt;'; (<span class="red">obligatoire pour une sortiel html ou array_html</span>)

echo (&quot;&lt;u1&gt;&quot;.<span class="red">$plxShow-&gt;callHook('spxdatas::getData',$o)</span>.&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<p>&nbsp;</p>
