<style type="text/css">
pre {
	font-size:14px;
	border: 1px solid #999;
	padding: 20px;
	white-space: pre-wrap;
	word-wrap: break-word;
	background-color: #FFF;
}
.red {color:red;}
</style>


<h2>C'est quoi ce plugin ?</h2>
<p>Ce plugin permet de créer une administration afin de gérer des données que vous aurez vous même définies. Il permet de stocker par exemple des galeries (images, titres, description), une liste de liens html, une liste de produits (titre, image, prix, description...). Il peut aussi lier certaines informations entres elles comme le fait pluxml avec les articles et les catégories. Ce plugin s'adresse à tout le monde à partir du moment où vous lisez la documentation.</p>
<h3>Un plugin qui ne fait rien sauf si on ne lui dit pas ce qu'il a à faire ? </h3>
<p>Oui. Vous êtes le chef d'orchestre. Spxdatas est un couteau suisse, il fera ce que vous lui dites de faire.</p>
<h3>Mais comment ? </h3>
<p>Pour que ça fonctionne, il va falloir lui donner des instructions au format xml. Ces instructions sont la description de votre futur administration de données. Pour cela on définit une base de données avec des tables.</p>
<h3>Une base de données avec des tables ?</h3>
<p>Une vraie base de données fonctionne avec des tables, ici le meme principe est appliqué. Une table dans une base de données est un ensemble de données organisées sous forme d'un tableau où les colonnes correspondent à des catégories d'informations (une colonne peut stocker des numéros de téléphone, une autre des noms...) et les lignes à des enregistrements, également appelées entrées. Ici, c'est à peu près semblable mais en beaucoup plus simple et avec des options propres a l'administration. La base xml, va se composer de une ou plusieurs tables selon votre usage. <strong>Chaque table porte un nom unique</strong>. A l'intérieur de la balise table on trouve une balise description de table.</p>
<h4>Exemple d'une base avec deux tables sans description du contenu :</h4>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />&lt;document&gt;<br />	&lt;table name=&quot;<span class="red">table1</span>&quot; &gt;
		&lt;description&gt;&lt;![CDATA[Description de la table 1]]&gt;&lt;/description&gt;<br />		...<br />	&lt;/table&gt;

	&lt;table name=&quot;<span class="red">table2</span>&quot; &gt;
		&lt;description&gt;&lt;![CDATA[Description de la table 2]]&gt;&lt;/description&gt;<br />		...<br />	&lt;/table&gt;<br />	<br />&lt;/document&gt;</pre>
<p>La description de chaque colonne (nom, téléphone, description) se trouve à l'intérieur d'une balise <strong>&lt;column&gt;</strong>. Chaque champ est défini avec une balise <strong>&lt;parameter&gt;</strong> comportant un nom unique, un type et une option permettant de décrire le champ dans l'administration.</p>
<h4>Exemple d'une base avec une table &quot;personne&quot; avec ses paramètres :</h4>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />&lt;document&gt;<br />	&lt;table name=&quot;personne&quot; &gt;<br />		&lt;description&gt;&lt;![CDATA[Description de la table personne avec 3 colonnes]]&gt;&lt;/description&gt;<br />		&lt;column&gt;<br />			<span class="red">&lt;parameter name=&quot;nom&quot; type=&quot;cdata&quot; option=&quot;textinput/15/20&quot;&gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;description&quot; type=&quot;cdata&quot; option=&quot;textarea/20/1&quot;&gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;telephone&quot; type=&quot;cdata&quot; option=&quot;textinput/15/20&quot;&gt;&lt;/parameter&gt;</span><br />                        <br />		&lt;/column&gt;<br />	&lt;/table&gt;<br />	<br />&lt;/document&gt;
</pre>
<h3>Il y a donc un langage ? </h3>
<p>Oui, il y a un langage spécifique de description qu'il va vous falloir connaitre. Ce langage est décrit dans cette aide et il va vous permettre de comprendre le fonctionnement de ce plugin. Ce dernier est un peu en marge de ce qui se fait d'habitude.</p>
<h3>Et la base xml finie qu'est ce qui se passe ?</h3>
<p>Le plugin prendra le relais et se chargera de créer votre base d'administration. Vous pourrez à tout moment la modifier, ajouter ou supprimer des tables, des colonnes. Vous pouvez commencer à faire vos enregistrements dans les tables. La modification de la base peux se faire à tout moment, il n'y aura aucune influence sur les enregistrements deja existants.</p>
<h3>L'admin c'est coté &quot;admin&quot; et coté &quot;client&quot; alors ? Comment récupérer les données qui ont été enregistrés ?</h3>
<p>Pour récupérer les données coté client, il y a une requete à faire au plugin en lui passant des paramètres tout simplement.</p>
<h3>Et le multilingue ?</h3>
<p>Le plugin peux devenir multilingue en cochant l'option multilingue dans le fichier de config. Le plugin <strong>plxMyMultiLingue</strong> doit être activé (merci à stéphane).</p>
<h3>Donc on commence par quoi ?</h3>
<ul>
  <li>Installation : On active le plugin spxdatas et le plugin spxlibrary (ce dernier installe des librairy pour le spxdatas (jquery...). On configure le plugin pour les chemins vers la base et l'enregistrement des données.</li>
</ul>
<ul>
  <li>Description de la base : On décrit une base de données selon les besoins. Voir la documentation et les nombreux exemples fournis.</li>
</ul>
<ul>
  <li>Administration : L'administration du plugin permet l'enregistrement des entrées dans les tables. Cette partie est faite automatiquement en fonction de la description de la base et suit la logique de pluxml.</li>
</ul>
<ul>
  <li>Coté site : Dans le template, la fonction &quot;spxdatas::getData&quot; permet de récupérer les données selons des critères (table, contraintes, ordre...). On a le choix en une sortie html, un tableau php ou les deux.</li>
</ul>
<h2>Installation :</h2>
<p>Pensez &agrave; activer le plugin spxdatas et le plugin spxlibrary et à editer le fichier de configuration de spxdatas.</p>
<h3>Configuration :   </h3>
<p>Il y a plusieurs paramètres dans la configuration :</p>
<ul>
  <li><strong>Nom du plugin admin</strong> : Le nom du plugin dans l'adminstration (default : &quot;Widgets&quot;)</li>
  <li><strong>Position du menu</strong> : la position dans l'administraton (défault : 1)</li>
  <li><strong>Legende du menu</strong> : La légende quand on est en rollover (défault : &quot;Gestion des widgets&quot;)</li>
  <li><strong>Chemin vers la base </strong>: Le chemin vers le fichier php de description de la base de données (défault : plugins/spxdatas/record/table/demo.php) - Pensez à autoriser les droits pour les enregistrements dans ce fichier.</li>
  <li><strong>Dossier pour les datas</strong> : Chaque table est recordée dans un fichier xml. Ce chemin précise ou les fichiers de datas seront recordés (default : plugins/spxdatas/record/data/) - Pensez a autoriser les droits pour les enregistrements dans ce dossier.</li>
  <li><strong>Nbre de ligne pour paginer</strong> : c'est le nombre de ligne maximum avant pagination dans l'administration du plugin (défault : 30)</li>
  <li><strong>Active le multilingue</strong> : Les données peuvent être enregistrées dans des dossiers de langue fonction de cette option. Pour que ça fonctionne, le plugin <strong>plxMyMultiLingue</strong> doit être activé et cette option cochée.</li>
  <li><strong>Active tinymce (WYSIWYG)</strong> : Cette option permet d'utiliser tinymce. Pour que ça fonctionne, le plugin <strong>spxlibrary</strong> doit être activé la librairy et l'option tynimce cochée coté admin.</li>
</ul>
<p><strong>Note</strong> : Par default les chemins de base et de données sont définis dans un dossier du plugin (/spxdatas/record/)</p>
<ul>
  <li>chemin des dossiers &quot;base&quot; par default : <strong>plugins/spxdatas/record/table/demo.php</strong></li>
  <li>chemin des dossiers &quot;data&quot; par default : <strong>plugins/spxdatas/record/data/</strong></li>
</ul>
<p>La base <strong>demo.php</strong> vous permettra de comprendre la structure d'une base de données.</p>
<p>Bien sur quand votre prise en main sera effective, il est recommandé de changer le chemin depuis la racine de pluxml comme suit :</p>
<ul>
  <li>chemin des dossiers &quot;base&quot;  recommandé : <strong>data/spxdatas/table/base.php</strong></li>
  <li>chemin dossier &quot;data&quot;  recommandé : <strong>data/spxdatas/data/</strong></li>
</ul>
<h2>Prise en main rapide par l'exemple</h2>
<h3>1) Gérer des liens html :</h3>
<p>Rien de mieux que de commencer dès maintenant. Je vous propose un petit exercice très simple. </p>
<p>Les besoins : nous voulons gérer une liste de liens html sous forme de liste administrable par le client. Rien de plus simple.</p>
<h4>Description de la base :</h4>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />&lt;document&gt;<br />	&lt;table name=&quot;<strong>link</strong>&quot; &gt;<br />		&lt;description&gt;&lt;![CDATA[<strong>Description de la table link</strong>]]&gt;&lt;/description&gt;<br />		&lt;column&gt;<br />			&lt;parameter name=&quot;<strong>name</strong>&quot; type=&quot;cdata&quot; option=&quot;textinput/15/20&quot;&gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;<strong>description</strong>&quot; type=&quot;cdata&quot; option=&quot;textarea/20/1&quot;&gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;<strong>link</strong>&quot; type=&quot;cdata&quot; option=&quot;textinput/30/100&quot;&gt;&lt;/parameter&gt;<br />                        <br />		&lt;/column&gt;<br />	&lt;/table&gt;<br />	<br />&lt;/document&gt;</pre>
<p>Comme on peut le voir ici, la structure de la base est relativement simple. On a juste besoin d'une table (link) contenant uniquement trois colonnes &quot;column&quot; qui sont &quot;name&quot;, &quot;description&quot;et &quot;link&quot;. </p>
<p>A noter : <strong>Une table a un nom unique</strong>. A l'intérieur,<strong> les differentes colonnes ont elles aussi un nom unique</strong> et comporte un <strong>typage</strong>. Nous reverrons ces notions plus loin.</p>
<h4>Administration :</h4>
<p>Cette description faite, la partie administration va créer une table link avec trois champs &quot;name&quot;, &quot;description&quot; et &quot;link&quot;. </p>
<p>Vous pouvez commencer a enregistrer quelques datas dans la partie administration. La partie administration du plugin reste simple et tout à fait dans l'esprit de l'admin de pluxml.<br />
  Avec notamment: </p>
<ul>
  <li>Supression, modification et insertion des entrées</li>
  <li>Une option pour chaque ligne permet d'avoir l'ensembles des champs de la table.</li>
</ul>
<h4>Récupération des données dans le template :</h4>
<p>Pour récupérer les données, il faut passer par le hook'<strong>spxdatas::getData</strong>'. Par exemple ici on récupère les liens sous forme de liste html. Un simple objet  est donné à la fonction getData. </p>
<p>A noter : Pour récupérer les données dans un template il n'y a qu'une fonction : <strong>spxdatas::getData</strong></p>
<pre>&lt;?php
global $plxShow;
$o= array();<br />$o[&quot;table&quot;]=&quot;link&quot;;
$o[&quot;out&quot;]=&quot;html&quot;;
$o[&quot;format&quot;]='&lt;li&gt;&lt;a href=&quot;#url&quot; title=&quot;#description&quot;&gt;#name&lt;/a&gt;&lt;/li&gt;';<br />
echo (&quot;&lt;u1&gt;&quot;.$plxShow-&gt;callHook('spxdatas::getData',$o).&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<h3>2) Gestion d'une base d'auteurs</h3>
<p>Un deuxième exemple vas nous démontrer qu'il est possible de lier deux tables entre elles permettant par exemple de trier les données en fonction de catégories ou autres.</p>
<p>Les besoins : nous voulons gérer une liste d'auteurs avec un classement spécifique par exemple : amateur ou professionnel.</p>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;<br />&lt;document&gt;<br />&lt;table name=&quot;auteur&quot; &gt;<br />		&lt;description&gt;&lt;![CDATA[liste des auteurs]]&gt;&lt;/description&gt;<br />		&lt;column&gt;<br />			&lt;parameter name=&quot;name&quot; type=&quot;cdata&quot; &gt;&lt;/parameter&gt;<br />            &lt;parameter name=&quot;surnname&quot; type=&quot;cdata&quot; &gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;categorie&quot; type=&quot;string&quot; <span class="red">option=&quot;liste/auteur_categorie/title&quot;&gt;</span>&lt;/parameter&gt;<br />			&lt;parameter name=&quot;telephone&quot; type=&quot;numeric&quot; &gt;&lt;/parameter&gt;<br />			&lt;parameter name=&quot;description&quot; type=&quot;cdata&quot; option=&quot;textarea/10/3&quot;&gt;&lt;/parameter&gt;<br />		&lt;/column&gt;<br />	&lt;/table&gt;<br />	&lt;table name=&quot;<span class="red">auteur_categorie</span>&quot;&gt;<br />		&lt;description&gt;&lt;![CDATA[Catégorie des auteurs]]&gt;&lt;/description&gt;<br />		&lt;column&gt;<br />			&lt;parameter name=&quot;<span class="red">title</span>&quot; type=&quot;cdata&quot;&gt;&lt;/parameter&gt;<br />		&lt;/column&gt;<br />	&lt;/table&gt;<br />&lt;/document&gt;</pre>
<p>Comme on le voit ici, nous avons deux tables. </p>
<ul>
  <li>Table auteur : Les auteurs et leurs caractéristiques (name, surname...)</li>
  <li>Table auteur_categorie : table des catégories permettant le filtre (amateur, pro...)</li>
</ul>
<p>La première table définie les auteurs avec une option spéciale sur les catégories (<span class="red">option=&quot;liste/auteur_categorie/title&quot;</span>).</p>
<p>Dans l'administration, il vous faudra créer des enregistrements pour les auteurs et les catégories d'auteurs avant de récupérer les données.</p>
<p> La recupération des données se fait dans le template via hook et un tableau  $o représentant la requete à la base: </p>
<ul>
  <li>$plxShow-&gt;callHook('spxdatas::getData' ,$o);</li>
  <li>Exemple de recupération des données avec formatage html dans une page statique pour la table link.</li>
</ul>
<pre>&lt;?php
global $plxShow;
  $o= array();
  $o[&quot;table&quot;]=&quot;auteur&quot;;
// on ne veux filtrer les auteurs dont l'id de catégorie est id=001
  <span class="red">$o[&quot;filter&quot;]=&quot;categorie=001&quot;;</span>
  $o[&quot;out&quot;]=&quot;html&quot;;
  $o[&quot;format&quot;]='
	&lt;address&gt;
		&lt;strong&gt;#name&lt;/strong&gt;&lt;br&gt;#surname&lt;br&gt;#description&lt;br&gt;
		&lt;abbr title=&quot;Phone&quot;&gt;P:&lt;/abbr&gt;#telephone<br />	&lt;/address&gt;';
 
// sortie html 
echo (&quot;&lt;u1&gt;&quot;.$plxShow-&gt;callHook('spxdatas::getData',$o).&quot;&lt;/u1&gt;&quot;);
?&gt;</pre>
<p>Note importante : </p>
<ul>
  <li>Le nombre de tables dans la base n'est pas limité. </li>
  <li>Ce plugin gère des enregistrements typés et hiérarchisés que vous avez définis. il n'y a donc pas vraiment de limite à votre propre base et à ce que vous en ferez coté client.</li>
 </ul>
  
 Avec un peu d'imagination vous pouvez créer des bases complexes et vous serez surement surpris du résultat...

