<?php

/**
 * Classe plxUtils rassemblant les fonctions utiles à PluXml
 *
 * @package PLX
 * @author	Florent MONTHEL et Stephane F
 **/
class spxdatasUtils {

	
	/**
	 * Méthode qui converti les liens relatifs en liens absolus
	 *
	 * @param	base		url du site qui sera rajoutée devant les liens relatifs
	 * @param	html		chaine de caractères à convertir
	 * @param	dirs		configuration des dossiers issues du fichier parametres.xml
	 * @return	string		chaine de caractères modifiée
	 * @author	Stephane F., Amaury Graillat
	 **/
	public static function rel2abs($base, $html) {

		// url des plugins
		$html = preg_replace('@\<([^>]*) (href|src)=(["\'])[\.]/plugins@i', '<$1 $2=$3'.$base.'plugins', $html);
		// generate server-only replacement for root-relative URLs
		$server = preg_replace('@^([^:]+)://([^/]+)(/|$).*@', '\1://\2/', $base);
		// on repare les liens ne commençant que part #
		$get = plxUtils::getGets();
		$html = preg_replace('@\<([^>]*) (href|src)="#@i', '<\1 \2="' . $get . '#', $html);
		// replace root-relative URLs
		$html = preg_replace('@\<([^>]*) (href|src)=".?/@i', '<\1 \2="' . $server, $html);
		// replace base-relative URLs
		$html = preg_replace('@\<([^>]*) (href|src)="([^:"]*|[^:"]*:[^/"][^"]*)"@i', '<\1 \2="' . $base . '\3"', $html);
		// unreplace fully qualified URLs with proto: that were wrongly added $base
		$html = preg_replace('@\<([^>]*) (href|src)="'. $base . '([^:"]+):@i', '<\1 \2="\3:', $html);
		return $html;

	}

	
	public static function dirToArray($dir) { 
	   
	   $result = array(); 
	
	   $cdir = scandir($dir); 
	   foreach ($cdir as $key => $value) 
	   { 
		  if (!in_array($value,array(".",".."))) 
		  { 
			 if (is_dir($dir . DIRECTORY_SEPARATOR . $value)) 
			 { 
				$result[$value] = self::dirToArray($dir . DIRECTORY_SEPARATOR . $value); 
			 } 
			 else 
			 { 
				$result[] = $value; 
			 } 
		  } 
	   } 
	   
	   return $result; 
	} 

	/**
     * Get an array that represents directory tree
     * @param string $directory     Directory path
     * @param bool $recursive         Include sub directories
     * @param bool $listDirs         Include directories on listing
     * @param bool $listFiles         Include files on listing
     * @param regex $exclude         Exclude paths that matches this regex
     */
   public static function directoryToArray($directory, $ds="/", $recursive = true, $listDirs = false, $listFiles = true, $exclude = '') { 
       // $directory_separator=DIRECTORY_SEPARATOR;
		$directory_separator=$ds;
		$arrayItems = array();
        $skipByExclude = false;
        $handle = opendir($directory);
        if ($handle) {
            while (false !== ($file = readdir($handle))) {
            preg_match("/(^(([\.]){1,2})$|(\.(svn|git|md))|(Thumbs\.db|\.DS_STORE))$/iu", $file, $skip);
            if($exclude){
                preg_match($exclude, $file, $skipByExclude);
            }
            if (!$skip && !$skipByExclude) {
                if (is_dir($directory. $directory_separator . $file)) {
                    if($recursive) {
                        $arrayItems = array_merge($arrayItems, self::directoryToArray($directory. $directory_separator . $file, $ds, $recursive, $listDirs, $listFiles, $exclude));
                    }
                    if($listDirs){
                        $file = $directory . $directory_separator . $file;
                        $arrayItems[] = $file;
                    }
                } else {
                    if($listFiles){
                        $file = $directory . $directory_separator . $file;
                        $arrayItems[] = $file;
                    }
                }
            }
        }
        closedir($handle);
        }
        return $arrayItems;
    }

	public static function send_mails($from,$subjet,$texte,$emails,$reply="") {
		if ($reply=="") $reply=$from;
		$headers = "From: ".$from."\n".
		"Return-Path: ".$reply."\n".
		"MIME-Version: 1.0\n".
		"Content-Type: text/plain; charset=iso-8859-1\n".
		"Content-Transfer-Encoding: 8bit\n";
		//foreach($emails as $email) mail($email, utf8_decode($subjet), utf8_decode($texte), $headers);
		foreach($emails as $email) {
			mail($email, utf8_decode($subjet), utf8_decode($texte), $headers);
		}

	}
	
	public static function send_mailsHtml($from,$subjet,$texte,$emails,$reply="") {
		if ($reply=="") $reply=$from;
		$headers = 'From: '.$from. "\n";
		$headers .="Return-Path: ".$reply."\n";
		$headers .= 'MIME-Version: 1.0'. "\n";
		$headers .= 'Content-type: text/html; charset="'.PLX_CHARSET.'"'."rn";
		$headers .='Content-Transfer-Encoding: 8bit'; // ici on précise qu'il y a des caractères accentués
		//foreach($emails as $email) mail($email, utf8_decode($subjet), utf8_decode($texte), $headers);
		foreach($emails as $email) {
			//echo ("email to ".$email." sujet=".$subjet."\n<br>");
			mail($email, $subjet, $texte, $headers);
		}

	}
	public static function get_checkboxBoolean($type,$name,$value,$number_id) {
		if ($type=="checkboxBooleanreverse"){
			if ($value=="") $value ="1";
		} else{
			if ($value=="") $value ="0";
		}
		if ($value =='1') $checked="checked ";
	
		$a = array('1'=>L_YES,'0'=>L_NO);

		$s='';
		$s='<input id="hidden_'.$name.$number_id.'" type="hidden" name="'.$name.$number_id.'[]" value="'.$value.'" />';
		$s.='<input id="fake_'.$name.$number_id.'"  type="checkbox" '.$checked.' class="class" value="1" >';
			// 
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'
			
			$("#fake_'.$name.$number_id.'").switchButton({
				on_label: "'.L_YES.'",
				off_label: "'.L_NO.'",
				
				show_labels: false
				});
			$( "#fake_'.$name.$number_id.'" ).change(function() {
  				
				var val = $(this).is(":checked");
				if (val==true) {
					console.log("true");
					$("#hidden_'.$name.$number_id.'").val(1);
				}else{
					$("#hidden_'.$name.$number_id.'").val(0);
				}
				
			});
			';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			
			
			return $s;
	}
	public static function get_checkboxlisteadmin($name,$value,$number_id) {
		# Tableau des profils
		$aProfils = array(
			PROFIL_ADMIN => L_PROFIL_ADMIN,
			PROFIL_MANAGER => L_PROFIL_MANAGER,
			PROFIL_MODERATOR => L_PROFIL_MODERATOR,
			PROFIL_EDITOR => L_PROFIL_EDITOR,
			PROFIL_WRITER => L_PROFIL_WRITER
		);
		
		
		$s="";
			
			# $value="001 002"
			$acheck=array();
			$acheck=explode(" ",$value);
			$acheck2=array();
			for ($i=0;$i<count($acheck);$i++){
				$acheck2[$acheck[$i]]=$acheck[$i];
			}
			
			foreach($aProfils as $key=>$val) {
				$valcheckbox = $val;
				$idcheckbox =$key; 
				$checked="";
				if ($acheck2[$idcheckbox]==$idcheckbox && $acheck2[$idcheckbox]!='') $checked="checked ";
				$s.='<input id="'.$idcheckbox.'" name="'.$name.$number_id.'[]" type="checkbox" '.$checked.' class="class" value="'.$idcheckbox.'" >';
				$s.= '<label for="test">'.$valcheckbox.'</label><br />';
			}
			
			return $s;
			
	}
	public static function get_checkboxliste($data,$column,$name,$value,$number_id) {
			$s="";
			
			# $value="001 002"
			$acheck=array();
			$acheck=explode(" ",$value);
			$acheck2=array();
			for ($i=0;$i<count($acheck);$i++){
				$acheck2[$acheck[$i]]=$acheck[$i];
			}
			foreach($data as $val) {
				$valcheckbox = $val["data"][$column]["value"];
				$idcheckbox = $val["number"];
				$checked="";
				if ($acheck2[$idcheckbox]==$idcheckbox) $checked="checked ";
				$s.='<input id="'.$idcheckbox.'" name="'.$name.$number_id.'[]" type="checkbox" '.$checked.' class="class" value="'.$idcheckbox.'" >';
				$s.= '<label for="test">'.$valcheckbox.'</label><br />';
			}
			
			return $s;
	
	}
	
	public static function get_checkboxlisteevolued($data,$aoption,$name,$value,$number_id) {
			$column = $aoption[2];
			
			
			$s="";
			# $value="001 002"
			$acheck=array();
			$acheck=explode(" ",$value);
			$acheck2=array();
			for ($i=0;$i<count($acheck);$i++){
				$acheck2[$acheck[$i]]=$acheck[$i];
			}
			$printarray = array();
			$printarray["none"]="No selection";
			foreach($data as $val) {
				$valcheckbox = $val["data"][$column]["value"];
				if (count($aoption)>3){
					$valcheckbox.= ": ".$val["data"][$aoption[3]]["value"]."";
				}
				
				$idcheckbox = $val["number"];
				$checked="";
				# display only checked
				if ($acheck2[$idcheckbox]==$idcheckbox) {
					$checked="checked ";
					$s.='<input id="'.$idcheckbox.'" name="'.$name.$number_id.'[]" type="checkbox" '.$checked.' class="class" value="'.$idcheckbox.'" >';
					$s.= '<label for="test">'.$valcheckbox.'</label><br />';
				}else{
					$printarray[$idcheckbox]=$valcheckbox;
				}
			}

			$out =self::printSelect ($name.$number_id.'[]', $printarray,$value);
			//$out .='<span class="medium green btsk add" >&nbsp;</span><br>';
			$out .='<br>'.$s;
			return $out;
	}
	public static function get_checkboxlisteUsersEvolued($name,$value,$number_id) {
			$s="";
			# $value="001 002"
			$acheck=array();
			$acheck=explode(" ",$value);
			$acheck2=array();
			for ($i=0;$i<count($acheck);$i++){
				$acheck2[$acheck[$i]]=$acheck[$i];
			}
			$printarray = array();
			$printarray["none"]="No selection";
			
			$plxAdmin =   plxAdmin::getInstance();
			foreach($plxAdmin->aUsers as $_userid => $_user) {
				if($_user['active'] AND !$_user['delete'] ) {
					$valcheckbox = plxUtils::strCheck($_user['name']);
					$idcheckbox = $_userid;
					$checked="";
					# display only checked
					if ($acheck2[$idcheckbox]==$idcheckbox) {
						$checked="checked ";
						$s.='<input id="'.$idcheckbox.'" name="'.$name.$number_id.'[]" type="checkbox" '.$checked.' class="class" value="'.$idcheckbox.'" >';
						$s.= '<label for="test">'.$valcheckbox.'</label><br />';
					}else{
						//$printarray[$idcheckbox]=$valcheckbox;
						
						
						if($_user['profil']==PROFIL_ADMIN)
							$printarray[L_PROFIL_ADMIN][$_userid] = $valcheckbox;
						elseif($_user['profil']==PROFIL_MANAGER)
							$printarray[L_PROFIL_MANAGER][$_userid] = $valcheckbox;
						elseif($_user['profil']==PROFIL_MODERATOR)
							$printarray[L_PROFIL_MODERATOR][$_userid] = $valcheckbox;
						elseif($_user['profil']==PROFIL_EDITOR)
							$printarray[L_PROFIL_EDITOR][$_userid] = $valcheckbox;
						else
							$printarray[L_PROFIL_WRITER][$_userid] = $valcheckbox;
						
						
						
					}
				}
			}
			
			$out =self::printSelect ($name.$number_id.'[]', $printarray,$value);
			//$out .='<span class="medium green btsk add" >&nbsp;</span><br>';
			$out .='<br>'.$s;
			return $out;
		
	}
	
	public static function get_listeUsers($name,$value) {
		# On construit la liste des utilisateurs
			$plxAdmin =   plxAdmin::getInstance();
			foreach($plxAdmin->aUsers as $_userid => $_user) {
				if($_user['active'] AND !$_user['delete'] ) {
					if($_user['profil']==PROFIL_ADMIN)
						$_users[L_PROFIL_ADMIN][$_userid] = plxUtils::strCheck($_user['name']);
					elseif($_user['profil']==PROFIL_MANAGER)
						$_users[L_PROFIL_MANAGER][$_userid] = plxUtils::strCheck($_user['name']);
					elseif($_user['profil']==PROFIL_MODERATOR)
						$_users[L_PROFIL_MODERATOR][$_userid] = plxUtils::strCheck($_user['name']);
					elseif($_user['profil']==PROFIL_EDITOR)
						$_users[L_PROFIL_EDITOR][$_userid] = plxUtils::strCheck($_user['name']);
					else
						$_users[L_PROFIL_WRITER][$_userid] = plxUtils::strCheck($_user['name']);
				}
			}
			return (self::printSelect ($name.'[]', $_users,$value));
	}
	
	
	
	public static function get_sliderMinMax($id,$name,$value,$min,$max) {
		$count = strlen((string)$max);
		
		$s = spxdatasUtils::printInput2 ($id, $name.'[]', $value, 'text', $count.'-'.$count,true);
		$s .= '<div id="slider-'.$id.'" style="width:50%" ></div>';
		
		$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
				$s.="\n\t".'$("#slider-'.$id.'").slider(
				{
				  range: "min",
				  min: '.$min.',
				  max: '.$max.',
				  value: '.$value.',
				  slide: function( event, ui ) {
					$( "#'.$id.'" ).val( ui.value );
				  }
				}
				
				
				);';
			$s.=	"\n\t".'});';
		$s.="\n\t".'</script>';
		
		
		return $s;
		
	}
	
	public static function get_listeImagePicker($id,$name,$value,$filelib,$subfile) {
		$fullfilelib=$filelib.$subfile;
		
		$_afile = self::dirToArray($fullfilelib);
		$s='<select class="image-picker masonry show-html" id="'.$id.'" name="'.$name.'[]">';
		for ($i=0;$i<count($_afile);$i++){
			//$_afile2[$_afile[$i]]=$_afile[$i];
			$selected='';
			$file = $_afile[$i];
			if ($subfile.$file == $value) $selected=' selected=selected';
			$s.='<option data-img-src="'.$fullfilelib.$file.'" '.$selected.' title="'.$file.'" value="'.$subfile.$file.'">'.$file.'</option>';
		}
		$s.='</select>';
		
		$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
				$s.="\n\t".'$("#'.$id.'").imagepicker(
			
				);';
			
			
				$s.='var container = $("#'.$id.'").next("ul.thumbnails");
					console.dir (container);
    				container.imagesLoaded(function(){ 
      					container.masonry({ 
        					itemSelector:   "li",
      					}); 
    				})';
				
			$s.=	"\n\t".'});';
		$s.="\n\t".'</script>';
		
		return $s;
		
	}
	
	public static function get_listeBuilderOption($data,$column,$name,$value) {
		$apluxml = array();
		$apluxml["cdata listestaticandcat"]="liste static and category";
		$apluxml["cdata listeUsers"]="liste users";
		$apluxml["cdata checkboxlisteUsersEvolued"]="checkbox2 users";
		$apluxml["cdata checkboxlisteAdmin"]="liste level admin";
		
		$aicon = array();
		$aicon["cdata icon/newsletter_status"]="icon newsletter";
		
		$aimage = array();
		$aimage["cdata image"]="image";
		
		$atext = array();
		$atext["cdata textinput/10/20"]="textinput very short";
		$atext["cdata textinput/20/30"]="textinput short";
		$atext["cdata textinput/30/100"]="textinput medium";
		$atext["cdata textinput/60/120"]="textinput long";
		$atext["cdata textarea/20/1"]="textarea short";
		$atext["cdata textarea/20/5"]="textarea short-medium";
		$atext["cdata textarea/40/10"]="textarea medium";
		$atext["cdata textarea/80/20"]="textarea long";
		$atext["cdata password/15/30"]="password short";
		
		$avarious = array();
		$avarious["cdata date"]="date";
		
		$aChoice = array();
		$aChoice["string boolean"]="yes / no";
		
		$alistScan=array();
		$alistScan["cdata scandirliste/images"]="media: image";
		
		$alistFromTable=array();
		$acheckboxlistFromTable=array();
		$acheckboxlisteevoluedFromTable=array();
		
		foreach($data as $val) {
			$valliste = $val["data"][$column]["value"];
			$idliste = $val["number"];
			$s="liste/".$valliste."/title";
			$s2="checkboxliste/".$valliste."/title";
			$s3="checkboxlisteevolued/".$valliste."/title";
			$alistFromTable["cdata ".$s]=$valliste.": title";
			$acheckboxlistFromTable["cdata ".$s2]=$valliste.": title";
			$acheckboxlisteevoluedFromTable["cdata ".$s3]=$valliste.": title";
		}
		
		$alistFromSubtable=array();
		foreach($data as $val) {
			$valliste = $val["data"][$column]["value"];
			$b = $val["data"]["subtable"]["value"];
			if ($b=="1"){
				$s="subtable/".$valliste;
				$alistFromSubtable["cdata ".$s]=$valliste;
			}
		}
		
		$acolorpicker = array();
		$acolorpicker["cdata colorpicker"]="colorpicker";
		
		$aimagepicker = array();
		$aimagepicker["cdata imagepickerDataImages/"]="imagepicker data/images/";
		$aimagepicker["cdata imagepickerThemesCurrentTheme/"]="imagepicker themes/current/";
		
		$printarray["Text"]=$atext;
		$printarray["Media upload"]=$aimage;
		$printarray["Various"]=$avarious;
		$printarray["Choice"]=$aChoice;
		$printarray["List from table"]=$alistFromTable;
		$printarray["Checkbox from table"]=$acheckboxlistFromTable;
		$printarray["Checkbox2 from table"]=$acheckboxlisteevoluedFromTable;
		$printarray["Add datas from subtable"]=$alistFromSubtable;
		
		$printarray["List scan directory"]=$alistScan;
		$printarray["List pluxml"]=$apluxml;
		$printarray["Icon"]=$aicon;
		
		
		$printarray["colorpicker"]=$acolorpicker;
		$printarray["imagepicker"]=$aimagepicker;
		
		
		return (self::printSelect ($name.'[]', $printarray,$value));
	}

	# print select
	public static function printSelect($name, $array, $selected='', $readonly=false, $class='', $id=true, $force_id='') {
		$s='';
		if(!is_array($array)) $array=array();

		$id = ($id?' id="id_'.$name.'"':'');
		if ($force_id!='') $id=' id="'.$force_id.'"';
		if($readonly)
			$s.= '<input type="hidden" name="'.$name.'" value="'.$selected.'" /><select'.$id.' name="'.$name.'" disabled="disabled" class="readonly">'."\n";
		else
			$s.= '<select'.$id.' name="'.$name.'"'.($class!=''?' class="'.$class.'"':'').'>'."\n";
		foreach($array as $a => $b) {
			if(is_array($b)) {
				$s.= '<optgroup label="'.$a.'">'."\n";
				foreach($b as $c=>$d) {
					//if ($c=="none") $c="";
					if($c == $selected)
						$s.= "\t".'<option value="'.$c.'" selected="selected">'.$d.'</option>'."\n";
					else
						$s.= "\t".'<option value="'.$c.'">'.$d.'</option>'."\n";
				}
				$s.= '</optgroup>'."\n";
			} else {
				//if ($a=="none") $a="";
				if($a == $selected)
					$s.= "\t".'<option value="'.$a.'" selected="selected">'.$b.'</option>'."\n";
				else
					$s.= "\t".'<option value="'.$a.'">'.$b.'</option>'."\n";
			}
		}
		$s.= '</select>'."\n";
		return $s;
	}
	
	# print select
	public static function printselectfontIconPicker($name, $array, $selected='', $readonly=false, $class='', $id=true, $force_id='') {
		$s='';
		if(!is_array($array)) $array=array();

		$id = ($id?' id="id_'.$name.'"':'');
		if ($force_id!='') $id=' id="'.$force_id.'"';
		if($readonly)
			$s.= '<input type="hidden" name="'.$name.'" value="'.$selected.'" /><select'.$id.' name="'.$name.'" disabled="disabled" class="readonly">'."\n";
		else
			$s.= '<select'.$id.' name="'.$name.'"'.($class!=''?' class="'.$class.'"':'').'>'."\n";
		$n=0;
		foreach($array as $a => $b) {
			$val='';
			if ($n==0) $val = ' value="" ';
			if(is_array($b)) {
				$s.= '<optgroup label="'.$a.'">'."\n";
				foreach($b as $c=>$d) {
					//if ($c=="none") $c="";
					if($c == $selected)
						$s.= "\t".'<option '.$val.' selected="selected">'.$d.'</option>'."\n";
					else
						$s.= "\t".'<option  '.$val.' >'.$d.'</option>'."\n";
				}
				$s.= '</optgroup>'."\n";
			} else {
				//if ($a=="none") $a="";
				if($a == $selected)
					$s.= "\t".'<option  '.$val.' selected="selected">'.$b.'</option>'."\n";
				else
					$s.= "\t".'<option  '.$val.' >'.$b.'</option>'."\n";
			}
			$n++;
		}
		$s.= '</select>'."\n";
		return $s;
	}
	
	# print input
	public static function printInput($name, $value='', $type='text', $size='30-100', $readonly=false, $class='') {
		$size = explode('-',$size);
		if($readonly)
			$s= '<input id="id_'.$name.'" name="'.$name.'" type="'.$type.'" class="readonly '.$class.'" value="'.$value.'" size="'.$size[0].'" maxlength="'.$size[1].'" readonly="readonly" />'."\n";
		else
			$s= '<input id="id_'.$name.'" name="'.$name.'" type="'.$type.'"'.($class!=''?' class="'.$class.'"':'').' value="'.$value.'" size="'.$size[0].'" maxlength="'.$size[1].'" />'."\n";
		
		return $s;
	}
	
	# print input with id
	public static function printInput2($id_name,$name, $value='', $type='text', $size='30-100', $readonly=false, $class='') {
		$size = explode('-',$size);
		if($readonly)
			$s= '<input id="'.$id_name.'" name="'.$name.'" type="'.$type.'" class="readonly" value="'.$value.'" size="'.$size[0].'" maxlength="'.$size[1].'" readonly="readonly" />'."\n";
		else
			$s= '<input id="'.$id_name.'" name="'.$name.'" type="'.$type.'"'.($class!=''?' class="'.$class.'"':'').' value="'.$value.'" size="'.$size[0].'" maxlength="'.$size[1].'" />'."\n";
		return $s;
	}
	
	# print area
	public static function printArea($name, $value='', $cols='', $rows='', $readonly=false, $class='') {
		if($readonly)
			$s= '<textarea id="id_'.$name.'" name="'.$name.'" class="readonly" cols="'.$cols.'" rows="'.$rows.'" readonly="readonly">'.$value.'</textarea>'."\n";
		else
			$s= '<textarea id="id_'.$name.'" name="'.$name.'"'.($class!=''?' class="'.$class.'"':'').' cols="'.$cols.'" rows="'.$rows.'">'.$value.'</textarea>'."\n";
			
		return $s;
	}
	
	//-------------------------FOLDER-----------------------------//
	public static function check_file_exist($filename){
		if (file_exists($filename)) {
    		return true;
		} else {
    		return false;
		}
	}
	# new dir
	public static function newDir($newdir) {
		if(!is_dir($newdir)) { # Si le dossier n'existe pas on le créer
			if(!mkdir($newdir,0755))
				return false;
			else
				return true;
		} else {
			return false;
		}
	
    }
	# copy dir
	public static function copyDir($source,$destination) {
		if(!copy($source,$destination))
			return false;
		else
			return true;
    }
	
	public static function deleteFile($file) {
		if (!@unlink($file)) {
    		return false;
		}else{
			return true;
		}
	}
	public static function copyFile($file,$newfile) {
		if (!@copy($file, $newfile)) {
    		return false;
		}else{
			return true;
		}
	}
	public static function createFile($file,$content) {
		$f = fopen($file, "w");
        if($f==false)
            die("unable to create file");
		fwrite($f,$content);
        fclose ($f);
		return $file;
	}
	
	# merge multifile in one file
	// Array of css files
	/* $file = array(
		'file1.php',
		'file2.php',
		'file3.php',
		'file4.php'
	);
	
	merge_file( $file,"output.php");	
	*/
	public static function merge_file( $a ,$myFile) {
		$fo = fopen($myFile, 'w') or die("can't open file");
		foreach ($a as $file) {
   			if (file_exists($file)) {
				$file_content = file_get_contents($file);
				fwrite($fo, $file_content);
			}
		}
		fclose($fo);
	}
	// spxdatasUtils::getFontawesomelist ()
	public static function getFontawesomelist () {
		$a= array(
		"No icon",
		"fa fa-copy",
		"fa fa-glass",
		"fa fa-music",
		"fa fa-search",
		"fa fa-envelope-o",
		"fa fa-heart",
		"fa fa-star",
		"fa fa-star-o",
		"fa fa-user",
		"fa fa-film",
		"fa fa-th-large",
		"fa fa-th",
		"fa fa-th-list",
		"fa fa-check",
		"fa fa-times",
		"fa fa-search-plus",
		"fa fa-search-minus",
		"fa fa-power-off",
		"fa fa-signal",
		"fa fa-cog",
		"fa fa-trash-o",
		"fa fa-home",
		"fa fa-file-o",
		"fa fa-clock-o",
		"fa fa-road",
		"fa fa-download",
		"fa fa-arrow-circle-o-down",
		"fa fa-arrow-circle-o-up",
		"fa fa-inbox",
		"fa fa-play-circle-o",
		"fa fa-repeat",
		"fa fa-refresh",
		"fa fa-list-alt",
		"fa fa-lock",
		"fa fa-flag",
		"fa fa-headphones",
		"fa fa-volume-off",
		"fa fa-volume-down",
		"fa fa-volume-up",
		"fa fa-qrcode",
		"fa fa-barcode",
		"fa fa-tag",
		"fa fa-tags",
		"fa fa-book",
		"fa fa-bookmark",
		"fa fa-print",
		"fa fa-camera",
		"fa fa-font",
		"fa fa-bold",
		"fa fa-italic",
		"fa fa-text-height",
		"fa fa-text-width",
		"fa fa-align-left",
		"fa fa-align-center",
		"fa fa-align-right",
		"fa fa-align-justify",
		"fa fa-list",
		"fa fa-outdent",
		"fa fa-indent",
		"fa fa-video-camera",
		"fa fa-picture-o",
		"fa fa-pencil",
		"fa fa-map-marker",
		"fa fa-adjust",
		"fa fa-tint",
		"fa fa-pencil-square-o",
		"fa fa-share-square-o",
		"fa fa-check-square-o",
		"fa fa-arrows",
		"fa fa-step-backward",
		"fa fa-fast-backward",
		"fa fa-backward",
		"fa fa-play",
		"fa fa-pause",
		"fa fa-stop",
		"fa fa-forward",
		"fa fa-fast-forward",
		"fa fa-step-forward",
		"fa fa-eject",
		"fa fa-chevron-left",
		"fa fa-chevron-right",
		"fa fa-plus-circle",
		"fa fa-minus-circle",
		"fa fa-times-circle",
		"fa fa-check-circle",
		"fa fa-question-circle",
		"fa fa-info-circle",
		"fa fa-crosshairs",
		"fa fa-times-circle-o",
		"fa fa-check-circle-o",
		"fa fa-ban",
		"fa fa-arrow-left",
		"fa fa-arrow-right",
		"fa fa-arrow-up",
		"fa fa-arrow-down",
		"fa fa-share",
		"fa fa-expand",
		"fa fa-compress",
		"fa fa-plus",
		"fa fa-minus",
		"fa fa-asterisk",
		"fa fa-exclamation-circle",
		"fa fa-gift",
		"fa fa-leaf",
		"fa fa-fire",
		"fa fa-eye",

		"fa fa-eye-slash",
		"fa fa-exclamation-triangle",
		"fa fa-plane",
		"fa fa-calendar",
		"fa fa-random",
		"fa fa-comment",
		"fa fa-magnet",
		"fa fa-chevron-up",
		"fa fa-chevron-down",
		"fa fa-retweet",
		"fa fa-shopping-cart",
		"fa fa-folder",
		"fa fa-folder-open",
		"fa fa-arrows-v",
		"fa fa-arrows-h",
		"fa fa-bar-chart-o",
		"fa fa-twitter-square",
		"fa fa-facebook-square",
		"fa fa-camera-retro",
		"fa fa-key",
		"fa fa-cogs",
		"fa fa-comments",
		"fa fa-thumbs-o-up",
		"fa fa-thumbs-o-down",
		"fa fa-star-half",
		"fa fa-heart-o",
		"fa fa-sign-out",
		"fa fa-linkedin-square",
		"fa fa-thumb-tack",
		"fa fa-external-link",
		"fa fa-sign-in",
		"fa fa-trophy",
		"fa fa-github-square",
		"fa fa-upload",
		"fa fa-lemon-o",
		"fa fa-phone",
		"fa fa-square-o",
		"fa fa-bookmark-o",
		"fa fa-phone-square",
		"fa fa-twitter",
		"fa fa-facebook",
		"fa fa-github",
		"fa fa-unlock",
		"fa fa-credit-card",
		"fa fa-rss",
		"fa fa-hdd-o",
		"fa fa-bullhorn",
		"fa fa-bell",
		"fa fa-certificate",
		"fa fa-hand-o-right",
		"fa fa-hand-o-left",
		"fa fa-hand-o-up",
		"fa fa-hand-o-down",
		"fa fa-arrow-circle-left",
		"fa fa-arrow-circle-right",
		"fa fa-arrow-circle-up",
		"fa fa-arrow-circle-down",
		"fa fa-globe",
		"fa fa-wrench",
		"fa fa-tasks",
		"fa fa-filter",
		"fa fa-briefcase",
		"fa fa-arrows-alt",
		"fa fa-users",
		"fa fa-link",
		"fa fa-cloud",
		"fa fa-flask",
		"fa fa-scissors",
		"fa fa-files-o",
		"fa fa-paperclip",
		"fa fa-floppy-o",
		"fa fa-square",
		"fa fa-bars",
		"fa fa-list-ul",
		"fa fa-list-ol",
		"fa fa-strikethrough",
		"fa fa-underline",
		"fa fa-table",
		"fa fa-magic",
		"fa fa-truck",
		"fa fa-pinterest",
		"fa fa-pinterest-square",
		"fa fa-google-plus-square",
		"fa fa-google-plus",
		"fa fa-money",
		"fa fa-caret-down",
		"fa fa-caret-up",
		"fa fa-caret-left",
		"fa fa-caret-right",
		"fa fa-columns",
		"fa fa-sort",
		"fa fa-sort-asc",
		"fa fa-sort-desc",
		"fa fa-envelope",
		"fa fa-linkedin",
		"fa fa-undo",
		"fa fa-gavel",
		"fa fa-tachometer",
		"fa fa-comment-o",
		"fa fa-comments-o",
		"fa fa-bolt",
		"fa fa-sitemap",
		"fa fa-umbrella",
		"fa fa-clipboard",
		"fa fa-lightbulb-o",
		"fa fa-exchange",
		"fa fa-cloud-download",
		"fa fa-cloud-upload",
		"fa fa-user-md",
		"fa fa-stethoscope",
		"fa fa-suitcase",
		"fa fa-bell-o",
		"fa fa-coffee",
		"fa fa-cutlery",
		"fa fa-file-text-o",
		"fa fa-building-o",
		"fa fa-hospital-o",
		"fa fa-ambulance",
		"fa fa-medkit",
		"fa fa-fighter-jet",
		"fa fa-beer",
		"fa fa-h-square",
		"fa fa-plus-square",
		"fa fa-angle-double-left",
		"fa fa-angle-double-right",
		"fa fa-angle-double-up",
		"fa fa-angle-double-down",
		"fa fa-angle-left",
		"fa fa-angle-right",
		"fa fa-angle-up",
		"fa fa-angle-down",
		"fa fa-desktop",
		"fa fa-laptop",
		"fa fa-tablet",
		"fa fa-mobile",
		"fa fa-circle-o",
		"fa fa-quote-left",
		"fa fa-quote-right",
		"fa fa-spinner",
		"fa fa-circle",
		"fa fa-reply",
		"fa fa-github-alt",
		"fa fa-folder-o",
		"fa fa-folder-open-o",
		"fa fa-smile-o",
		"fa fa-frown-o",
		"fa fa-meh-o",
		"fa fa-gamepad",
		"fa fa-keyboard-o",
		"fa fa-flag-o",
		"fa fa-flag-checkered",
		"fa fa-terminal",
		"fa fa-code",
		"fa fa-reply-all",
		"fa fa-mail-reply-all",
		"fa fa-star-half-o",
		"fa fa-location-arrow",
		"fa fa-crop",
		"fa fa-code-fork",
		"fa fa-chain-broken",
		"fa fa-question",
		"fa fa-info",
		"fa fa-exclamation",
		"fa fa-superscript",
		"fa fa-subscript",
		"fa fa-eraser",
		"fa fa-puzzle-piece",
		"fa fa-microphone",
		"fa fa-microphone-slash",
		"fa fa-shield",
		"fa fa-calendar-o",
		"fa fa-fire-extinguisher",
		"fa fa-rocket",
		"fa fa-maxcdn",
		"fa fa-chevron-circle-left",
		"fa fa-chevron-circle-right",
		"fa fa-chevron-circle-up",
		"fa fa-chevron-circle-down",
		"fa fa-html5",
		"fa fa-css3",
		"fa fa-anchor",
		"fa fa-unlock-alt",
		"fa fa-bullseye",
		"fa fa-ellipsis-h",
		"fa fa-ellipsis-v",
		"fa fa-rss-square",
		"fa fa-play-circle",
		"fa fa-ticket",
		"fa fa-minus-square",
		"fa fa-minus-square-o",
		"fa fa-level-up",
		"fa fa-level-down",
		"fa fa-check-square",
		"fa fa-pencil-square",
		"fa fa-external-link-square",
		"fa fa-share-square",
		"fa fa-compass",
		"fa fa-caret-square-o-down",
		"fa fa-caret-square-o-up",
		"fa fa-caret-square-o-right",
		"fa fa-eur",
		"fa fa-gbp",
		"fa fa-usd",
		"fa fa-inr",
		"fa fa-jpy",
		"fa fa-rub",
		"fa fa-krw",
		"fa fa-btc",
		"fa fa-file",
		"fa fa-file-text",
		"fa fa-sort-alpha-asc",
		"fa fa-sort-alpha-desc",
		"fa fa-sort-amount-asc",
		"fa fa-sort-amount-desc",
		"fa fa-sort-numeric-asc",
		"fa fa-sort-numeric-desc",
		"fa fa-thumbs-up",
		"fa fa-thumbs-down",
		"fa fa-youtube-square",
		"fa fa-youtube",
		"fa fa-xing",
		"fa fa-xing-square",
		"fa fa-youtube-play",
		"fa fa-dropbox",
		"fa fa-stack-overflow",
		"fa fa-instagram",
		"fa fa-flickr",
		"fa fa-adn",
		"fa fa-bitbucket",
		"fa fa-bitbucket-square",
		"fa fa-tumblr",
		"fa fa-tumblr-square",
		"fa fa-long-arrow-down",
		"fa fa-long-arrow-up",
		"fa fa-long-arrow-left",
		"fa fa-long-arrow-right",
		"fa fa-apple",
		"fa fa-windows",
		"fa fa-android",
		"fa fa-linux",
		"fa fa-dribbble",
		"fa fa-skype",
		"fa fa-foursquare",
		"fa fa-trello",
		"fa fa-female",
		"fa fa-male",
		"fa fa-gittip",
		"fa fa-sun-o",
		"fa fa-moon-o",
		"fa fa-archive",
		"fa fa-bug",
		"fa fa-vk",
		"fa fa-weibo",
		"fa fa-renren",
		"fa fa-pagelines",
		"fa fa-stack-exchange",
		"fa fa-arrow-circle-o-right",
		"fa fa-arrow-circle-o-left",
		"fa fa-caret-square-o-left",
		"fa fa-dot-circle-o",
		"fa fa-wheelchair",
		"fa fa-vimeo-square",
		"fa fa-try"
		);
		return $a;
		
	}

	# spxUtils::getGooglefont(array("http://fonts.googleapis.com/css?family=Oswald:400,300","http://fonts.googleapis.com/css?family=Roboto+Slab"))
	public static function getGooglefont($urls) {
		// $urls = array("http://fonts.googleapis.com/css?family=Oswald:400,300",
		// "http://fonts.googleapis.com/css?family=Roboto+Slab");
		
		$patterns = array(
			  //replace the path root
		'!^http://fonts.googleapis.com/css\?!',
			  //capture the family and avoid and any following attributes in the URI.
		'!(family=[^&:]+).*$!',
			  //delete the variable name
		'!family=!',
			  //replace the plus sign
		'!\+!');
		$replacements = array(
		"",
		'$1',
		'',
		' ');
		
		$out = array();
		foreach($urls as $url){
			$font = preg_replace($patterns,$replacements,$url);
			//echo $font."\n<br>";
			array_push ($out,$font);
		}
		return $out;
	}
	
	public static function get_site_protocol() {
    	if(isset($_SERVER['HTTPS']) && ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) || isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&  $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https')  return $protocol = 'https://'; else return $protocol = 'http://';
	}
	
	public static function get_string_protocol($s) {
		return parse_url($s, PHP_URL_SCHEME)."://";
	}

//$check = spxUtils::getGooglefont(array("http://fonts.googleapis.com/css?family=Oswald:400,300","http://fonts.googleapis.com/css?family=Roboto+Slab"));
//print_r($check);

	
	/*
	
	
	public static function deleteFolder($directory){
		$directory = escapeshellarg($directory);
		exec("rm -rf $directory");
	}
	public static function createFolder($path) {
		if (!@mkdir($path, 0777, true)) {
			//ucmsUtils::tracer("can't create folder: ".$path);
    		return $path;
		}else{
			return $path;
		}
	}
	public static function copyFolder( $source, $destination ) {
		$s = "cp ".$source." ".$destination." -R";
		exec($s);
	}
	


*/





/*
	function arrayRemoveDuplicate($array, $field) {
		foreach ($array as $element)
			$cmp[] = $element[$field];
		$unique = array_unique($cmp);
		foreach ($unique as $k => $v)
			$new[] = $array[$k];
		return $new;
	}
*/
}
?>