<?php
/*
	Permet le record de datas dans des tables fonction de la description d'une base au format xml
	Auteur : jerome evrard
*/

class spxdatas extends plxPlugin {

	protected $aTables=array();  # tableau des infos sur les diffrentes tables
	protected $bTablesLoaded=false;
	protected $aDatas=array();  # tableau des infos sur les datas de la table slectionne
	protected $file_spxdatas="";
	protected $file_spxdatas_builderdata="";
	protected $file_spxdatas_table="";
	protected $file_spxdatas_data="";
	
	protected $file_table="";  # file de la table
	protected $folder_table="";  # folder de la table
	protected $folder_data="";  # folder des datas
	protected $nb_data_pagination=5;
	protected $sfiltergroupe="";
	# admin or builder for request
	protected $smode="admin";
	
	// 0 1 2 3 4
	// plxUtils::strCheck($plxAdmin->aUsers[$_SESSION['user']]['name']) 
	// $_SESSION['profil']==PROFIL_MANAGER
	// protected $aProfil=array(PROFIL_ADMIN, PROFIL_MANAGER, PROFIL_MODERATOR, PROFIL_EDITOR, PROFIL_WRITER);
	// id user $_SESSION['user']
	// profil $_SESSION['profil'] 0 to 4 
	// username echo ("name : ".plxUtils::strCheck($plxAdmin->aUsers[$_SESSION['user']]['name']));
	// $id = $_SESSION['user'];
	// $name = plxUtils::strCheck($plxAdmin->aUsers[$id]['name']);
	
	# Constructeur
	public function __construct($default_lang) {
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		$this->initconfiguration();
		# limite l'accs  l'cran d'administration du plugin
		$this->setConfigProfil(PROFIL_ADMIN);
		#  limite l'accs  l'cran d'administration du plugin
		$this->setAdminProfil(PROFIL_ADMIN, PROFIL_MANAGER, PROFIL_MODERATOR, PROFIL_EDITOR, PROFIL_WRITER);
		# Personnalisation du menu admin
		//$this->setAdminMenu('Titre du menu', 3, 'Lgende du lien');
		$this->setAdminMenu($this->getParam('mnuName'), $this->getParam('mnuPos'), $this->getParam('mnuCaption'));
		# Dclaration des hooks / admin et dans le plugin
		//$this->addHook('AdminPrepend', 'AdminPrepend');
		$this->AdminPrepend();
		
		if(defined('PLX_ADMIN')) {
			$querystring = $_SERVER['QUERY_STRING'];
			if(preg_match('/(spxdatas)/', $querystring)) {
				$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
			}
		}
		
		
		$this->addHook('spxdatas::delData', 'delData');
		$this->addHook('spxdatas::getData', 'getData');
		$this->addHook('spxdatas::setData', 'setData');
		
		$this->addHook('spxdatas::setSubData', 'setSubData');
		$this->addHook('spxdatas::delSubData', 'delSubData');
		
		
		$this->nb_data_pagination=$this->getParam('nb_data_pagination');
		
		$this->file_spxdatas=PLX_ROOT.$this->getParam('file_spxdatas');
		
		$this->file_spxdatas_builderdata=PLX_ROOT.$this->getParam('file_spxdatas_builderdata');
		$this->file_spxdatas_table=PLX_ROOT.$this->getParam('file_spxdatas_table');
		$this->file_spxdatas_data=PLX_ROOT.$this->getParam('file_spxdatas_data');
		
		if (!isset ($_SESSION['spxdata'])) {
			$_SESSION['spxdata']=array();
			$_SESSION['spxdata']['adminmode']="";
			$_SESSION['spxdata']['mode']="";
		}
		
		if(!empty($_GET['mode']) ) {
			$_SESSION['spxdata']= array();
			$this->setAdminMode($_GET['mode']);
			$this->setMode($_GET['mode']);
		}else{
			$this->setMode($this->getMode());
		}
		
		if ($this->nb_data_pagination<=2) $this->nb_data_pagination=5;
		
		# check multilingue
		if ($this->getParam('multilingue')=='1') $this->__checkmultilingue();
		# fix security
		$this->__cfixsecurity($this->folder_data);
		$a = pathinfo($this->file_table);
		$this->__cfixsecurity($a["dirname"]."/");
		
	} 
	
	# when admin.php
	public function initadmin() {
		$this->loadLangAdmin();
	}
	
	# add utils class
	public function AdminPrepend() {
		require_once(dirname(__FILE__).'/lib/class.spxdatas.utils.php');
		require_once(dirname(__FILE__).'/lib/class.spxdatas.actions.php');
		require_once(dirname(__FILE__).'/lib/class.spxdatas.jsonmanager.php');
		require_once(dirname(__FILE__).'/lib/class.spxdatas.xmlmanager.php');
	}
	
	# add css and js
	public function AdminTopEndHead() {
		 $this->addJSlibrairy();
		
		echo "\n\t".'<script type="text/javascript" src="'.PLX_PLUGINS.'spxdatas/vignette.js"></script>';
		echo "\n\t"."<link rel='stylesheet' type='text/css' href='./".PLX_PLUGINS."spxdatas/css/style.css' media='screen' />"; 
		
	}
	
	# init configuration
	public function initconfiguration() {
		if (plxUtils::strCheck($this->getParam('mnuName'))=="") $this->setParam('mnuName','Widgets','string');
		if (plxUtils::strCheck($this->getParam('mnuPos'))=="") $this->setParam('mnuPos','1','numeric');
		if (plxUtils::strCheck($this->getParam('mnuCaption'))=="") $this->setParam('mnuCaption','Gestion des widgets','string');
		if (plxUtils::strCheck($this->getParam('file_spxdatas'))=="") $this->setParam('file_spxdatas','plugins/spxdatas/builder/','string');
		# advanced param for evento
		if (plxUtils::strCheck($this->getParam('advancedparam'))=="") $this->setParam('advancedparam','0','string');
		if (plxUtils::strCheck($this->getParam('file_spxdatas_builderdata'))=="") $this->setParam('file_spxdatas_builderdata','plugins/spxdatas/builder/builderdata/','string');
		if (plxUtils::strCheck($this->getParam('file_spxdatas_table'))=="") $this->setParam('file_spxdatas_table','plugins/spxdatas/builder/table/','string');
		if (plxUtils::strCheck($this->getParam('file_spxdatas_data'))=="") $this->setParam('file_spxdatas_data','plugins/spxdatas/builder/data/','string');
		#
		
		if (plxUtils::strCheck($this->getParam('file_table'))=="") $this->setParam('file_table','default','string');
		if (plxUtils::strCheck($this->getParam('nb_data_pagination'))=="") $this->setParam('nb_data_pagination','30','numeric');
		if (plxUtils::strCheck($this->getParam('multilingue'))=="") $this->setParam('multilingue','0','string');
		if (plxUtils::strCheck($this->getParam('btinymce'))=="") $this->setParam('btinymce','1','string');
		if (plxUtils::strCheck($this->getParam('bgroupall'))=="") $this->setParam('bgroupall','0','string');
	}
	
	# get mode and return mode admin or builder
	public function getMode() {
		if ($_SESSION['spxdata']['mode']=="") {
			$this->setMode($this->smode);
		}else{
			$this->setMode($_SESSION['spxdata']['mode']);
		}
		return $this->smode;
	}
	
	# return mode admin or builder
	public function setMode($s) {
		$_SESSION['spxdata']['mode']=$s;
		$this->smode=$s;
		$this->checkMode();
		return $this->smode;
	}
	
	# define admin mode record
	public function setAdminMode($s) {
		$_SESSION['spxdata']['adminmode']=$s;
	}
	
	# get record file not use now remplace
	public function getFileSpxdatas() {
		return $this->file_spxdatas;
	}
	
	# must check if optionnel param is actived ? use by action
	public function getPathBuilderDatas() {
		if ($this->getParam('advancedparam')=="1"){
			return $this->file_spxdatas_builderdata;
		}else{
			return $this->file_spxdatas."builderdata/";
		}
	}
	
	public function getPathTable() {
		if ($this->getParam('advancedparam')=="1"){
			return $this->file_spxdatas_table;
		}else{
			return $this->file_spxdatas."table/";
		}
	}
	
	public function getPathData() {
		if ($this->getParam('advancedparam')=="1"){
			return $this->file_spxdatas_data;
		}else{
			return $this->file_spxdatas."data/";
		}
	}
	
	# get base url for error in config (if no data base it doesn't work)
	public function getBaseURL() {
		$filename=$this->getPathTable().$this->getParam('file_table').".php";
		return $filename;
	}
	
	# get base name use by base_edit.php
	public function getBaseName() {
		return $this->getParam('file_table');
	}
	
	# test in progress
	private function checkMode() {
		$mode = $this->smode;
		if(defined('PLX_ADMIN') && $_SESSION['spxdata']['adminmode']=="builder") {
			$mode="builder";
		}
		
		switch ($mode) {
			case "builder":
				
				# no change for table builder
				$this->file_table=PLX_ROOT."plugins/spxdatas/builder/buildertable/builder.php";
				$this->folder_table=PLX_ROOT."plugins/spxdatas/builder/buildertable/";
				# must change
				$this->folder_data=$this->getPathBuilderDatas();
				
			break;
			default:
				
				$this->file_table=$this->getPathTable().$this->getParam('file_table').".php";
				$this->folder_table=$this->getPathTable();
				$this->folder_data=$this->getPathData();
				
				# check multilingue
				if ($this->getParam('multilingue')=='1') $this->__checkmultilingue();
				# fix security
				$a = pathinfo($this->file_table);
				$this->__cfixsecurity($a["dirname"]."/");
				
			break;
		}
		# fix security
		$this->__cfixsecurity($this->folder_data);
	}
	
	# get group wanted
	public function setFilterGroupe() {
		# On check pour avoir le numero de page
		if(!empty($_GET['groupe']) )
			$this->sfiltergroupe = $_GET['groupe'];
		else
			$this->sfiltergroupe = !empty($_SESSION['spxdata']['groupe'])?($_SESSION['spxdata']['groupe']):"all";
		# On sauvegarde
		$_SESSION['spxdata']['groupe'] = $this->sfiltergroupe;
		
		return $this->sfiltergroupe;
	}
	
	# get a groupe
	public function getaGroupe() {
		$a= array();
		foreach($this->aTables as $k=>$v) {
			$groupe = $this->aTables[$k]["groupe"];
			$type = $this->aTables[$k]["type"];
			if ($type=="default"){
				if ($this->__getTableAutorized($k) ) $a[$groupe]=$groupe;
			}
		}
		$b=array();
		foreach($a as $k=>$v) {
			if ($k!=""){
				array_push ($b,$k);
			}
		}
		return $b;
	}
	
	# get group from table 
	public function checkGroupFromTable($table,$bdefaultonly=true) {
		$groupe = $this->aTables[$table]["groupe"];
		$type = $this->aTables[$table]["type"];
		# remove subtable if needed
		if ($type=="subtable" && $bdefaultonly==true) return false;
		if ($this->sfiltergroupe == "all" || $this->sfiltergroupe=="") return true;
		if ($this->sfiltergroupe == $groupe) {
			return true;
		}else{
			return false;
		}
	}
	
	# manage the subtable
	public function checkSubtable($want) {
		switch ($want) {
			case "get_path":
				if ($this->sSubtable != ""){
					$s = $this->folder_data.$this->sSubtable.".xml";
					return  $s;
				}else{
					return false;
				}
				//$this->sSubtable
			break;
			case "get_info":
				if ($this->sSubtable != ""){
					$o=array();
					$ainfos = explode (".",$this->sSubtable);
					$o["table"]=$ainfos [0];
					$o["table_data_id"]=$ainfos [1];
					$o["column_name"]=$ainfos [2];
					$o["subtable"]=$ainfos [3];
					$o["url"]=$this->sSubtable;
					return $o;
				}else{
					return false;	
				}
				//$this->sSubtable
			break;
			case "reset":
				$this->sSubtable="";
				$_SESSION['spxdata']['subtable'] ="";
			break;
			# since a link with option : subtable/tableb
			case "setsubtable":
				# On check pour avoir la table subtable
				if(!empty($_GET['subtable']) )
					$this->sSubtable = $_GET['subtable'];
				else
					$this->sSubtable = !empty($_SESSION['spxdata']['subtable'])?($_SESSION['spxdata']['subtable']):"";
				# On sauvegarde
				$_SESSION['spxdata']['subtable'] = $this->sSubtable;
				
				return $this->sSubtable;
			break;
			default:
			break;
		}
	}
	
	# get filter get from data_liste
	public function getAdminFilter($table,$n,$selected) {
		$option = $this->aTables[$table]["column"][$n]["option"];
		$name = $this->aTables[$table]["column"][$n]["name"];
		if ($option[0]=="liste" ){
			$table2 = $option[1];
			$column = $option[2];				
			$data = $this->aDatas[$table2];
			$printarray = array();
			$printarray['all']=$this->getLang('L_NO_FILTER');
			foreach($data as $val) {
				$valliste = $val["data"][$column]["value"];
				$idliste = $val["number"];
				$printarray[$idliste]=$valliste;
			}
			$selected = $_SESSION['spxdata']['filter'][$table][$name];
			
			return (spxdatasUtils::printSelect ('filter_'.$name, $printarray,$selected));
		}else{
			return '&nbsp;';
		}
	}
	
	# record filter in session after post list
	public function checkAdminFilter($content) {
		if ($content['submit']){ 
			$table = $content["table_name"];
			$ncolumn = count($this->aTables[$table]["column"]);
			for($i=0; $i<$ncolumn; $i++) {
				$name = $this->aTables[$table]["column"][$i]["name"];
				$option = $this->aTables[$table]["column"][$i]["option"];
				if ($option[0]=="liste"){
					$filter="filter_".$name;
					$value = $content[$filter];	
				//echo ("SESSION !!!$value!!");
					$_SESSION['spxdata']['filter'][$table][$name]=$value;
				}
			}
		}
	}
	
	# get cmd from table
	public function getCMD($table) {
		return $this->__getCMD($table);
	}
	
	# get if need order
	public function getneedorder($table) {
		return $this->aTables[$table]["needorder"];
	}
	
	# get total record
	public function getTotalRecord($table) {
		return count($this->aDatas[$table]);
	}
	
	# get total record user
	public function getTotalRecordUser($table) {
		$data = $this->aDatas[$table];
		$n=0;	
		if (is_array($data)){
			foreach($data as $val) {
				if ($val["user"]==$_SESSION['user']){
					$n++;
				}
			}
		}
		return $n;
	}
	
	# get current page
	public function getCurrentPage() {
		return $this->page;
	}
	
	# return lest page
	public function getLastPage() {
		return $this->last_page;
	}
	
	# return n current page
	public function checkCurrentRecordPage($data_file_name,$ntotal=null) {
		# On check pour avoir le numero de page
		if(!empty($_GET['pager']) AND is_numeric($_GET['pager']) AND $_GET['pager'] > 0)
			$this->page = $_GET['pager'];
		else
			$this->page = !empty($_SESSION['spxdata']['page'][$data_file_name])?intval($_SESSION['spxdata']['page'][$data_file_name]):1;
		# On sauvegarde
		$_SESSION['spxdata']['page'][$data_file_name] = $this->page;
		
		if ($ntotal==null){
			$n = count($this->aDatas[$data_file_name]);
		}else{
			$n = $ntotal;
		}
		
		$this->last_page = ceil($n/$this->nb_data_pagination);
		if ($this->page > $this->last_page ) $this->page=1;
		return $this->page;
	}
	
	# get datas
	public function getData($o,$keepmode=false) {
		# keep mode admin to get data from site
		if ($keepmode==false) $this->setMode("admin");
		//return $this->__checkCacheNeeded($o);
		return $this->__getData($o);
	}
	
	# load tables
	public function loadTables($s="") {
		if ($this->bTablesLoaded==true){
			return "ok";
		}
		
		if ($s=="") $s=$this->file_table;
		if(!is_file($s)) return "ko";

		# Mise en place du parseur XML
		$data = implode('',file($s));
		
		
		$data = $this->addons_table_plugins($data);
		
		$parser = xml_parser_create(PLX_CHARSET);
		xml_parser_set_option($parser,XML_OPTION_CASE_FOLDING,0);
		xml_parser_set_option($parser,XML_OPTION_SKIP_WHITE,0);
		xml_parse_into_struct($parser,$data,$values,$iTags);
		xml_parser_free($parser);
		
		
		$n= count($values);
		for($i = 0; $i < $n; $i++) {
			$tag = $values[$i]["tag"];
			$type= $values[$i]["type"];
			
			if ($tag =="table" && $type=="open"){
				
				$name= $values[$i]["attributes"]["name"];
				$num= $values[$i]["attributes"]["number"];
				$groupe= $values[$i]["attributes"]["groupe"];
				
				// default subtable ...
				$stable_type= $values[$i]["attributes"]["type"];
				if ($stable_type =="") $stable_type="default";
				
				$maxparam= $values[$i]["attributes"]["maxparam"];
				if ($maxparam =="") $maxparam=10;
				
				$maxrecord= $values[$i]["attributes"]["maxrecord"];
				if ($maxrecord =="") $maxrecord=99999999999999;
				
				$maxrecorduser= $values[$i]["attributes"]["maxrecorduser"];
				if ($maxrecorduser =="") $maxrecorduser=99999999999999;
				
				$dataformat= $values[$i]["attributes"]["dataformat"];
				if ($dataformat =="") $dataformat="xml";
				
				if ($values[$i]["attributes"]["order"] =="true"){
					$bneedorder=true;
				} else{
					$bneedorder=false;
				}
				
				$tableuserlevel= $values[$i]["attributes"]["tableuserlevel"];
				if ($tableuserlevel =="") $tableuserlevel="0,1,2,3,4";
				
				$tableuserinclude= $values[$i]["attributes"]["tableuserinclude"];
				$tableuserexclude= $values[$i]["attributes"]["tableuserexclude"];
				
				# current user can see this record ?
				
				$datauserlevel= $values[$i]["attributes"]["datauserlevel"];
				if ($datauserlevel =="") $datauserlevel="0,1,2,3,4";
				
				$datauserinclude= $values[$i]["attributes"]["datauserinclude"];
				$datauserexclude= $values[$i]["attributes"]["datauserexclude"];
				
				$rightCMDlevel= $values[$i]["attributes"]["rightCMDlevel"];
				$rightCMDuser= $values[$i]["attributes"]["rightCMDuser"];
			
				$this->aTables[$name]=array();
				$this->aTables[$name]["name"]=$name;
				$this->aTables[$name]["number"]=$num;
				$this->aTables[$name]["groupe"]=$groupe;
				$this->aTables[$name]["maxparam"]=$maxparam;
				$this->aTables[$name]["maxrecord"]=$maxrecord;
				$this->aTables[$name]["maxrecorduser"]=$maxrecorduser;
				$this->aTables[$name]["needorder"]=$bneedorder;
				$this->aTables[$name]["type"]=$stable_type;
				$this->aTables[$name]["dataformat"]=$dataformat;
				
				
				$this->aTables[$name]["user"]=array();
				$this->aTables[$name]["user"]["tableuserlevel"]=explode (",",$tableuserlevel);
				$this->aTables[$name]["user"]["tableuserinclude"]=explode (",",$tableuserinclude);
				$this->aTables[$name]["user"]["tableuserexclude"]=explode (",",$tableuserexclude);
				$this->aTables[$name]["user"]["datauserlevel"]=explode (",",$datauserlevel);
				$this->aTables[$name]["user"]["datauserinclude"]=explode (",",$datauserinclude);
				$this->aTables[$name]["user"]["datauserexclude"]=explode (",",$datauserexclude);
				$this->aTables[$name]["user"]["rightCMDlevel"]=explode (",",$rightCMDlevel);
				$this->aTables[$name]["user"]["rightCMDuser"]=explode (",",$rightCMDuser);
				
				$this->aTables[$name]["column"]=array();
			}
			if ($tag =="parameter"){
				$paramname= $values[$i]["attributes"]["name"];
				$paramtype= $values[$i]["attributes"]["type"];
				$paramoption= $values[$i]["attributes"]["option"];
				
				$aparamoption=explode("/",$paramoption);
				$tmp = array();
				$tmp["name"]=$paramname;
				$tmp["type"]=$paramtype;
				$tmp["option"]=$aparamoption;
				
				if ($values[$i]["attributes"]["reado"]=="1"){
					$tmp["reado"]=true;
				}else{
					$tmp["reado"]=false;
				}
				
				
				array_push ($this->aTables[$name]["column"],$tmp);
				
			}
			if ($tag =="description" && $type=="complete"){
				$this->aTables[$name]["description"]=$values[$i]["value"];
			}
			#actions
			if ($tag =="actions" && $type=="open"){
				$action_name = $values[$i]["attributes"]["name"];
				$action_type = $values[$i]["attributes"]["actiontype"];
				$this->aTables[$name]["actions"]=array();
				$this->aTables[$name]["actions"]["name"]=$action_name;
				$this->aTables[$name]["actions"]["action_type"]=$action_type;
				//[tag] => action_description
           		// [type] => complete
			}
			if ($tag =="actions_property" && $type=="complete"){
				$this->aTables[$name]["actions"]["property"]= $values[$i]["value"];
			}
		}
		$this->bTablesLoaded = true;
		return "ok";	
	}
	
	# get tables
	public function getTables($bdefaultonly=true) {
		$aTablesList = array();
		foreach($this->aTables as $table){
			$tableNam = $table["name"];
			$table_type= $table["type"];
			if ( $this->__getTableAutorized($tableNam) && $this->checkGroupFromTable($tableNam,$bdefaultonly)){
				$aTablesList[$tableNam]=array();
				$aTablesList[$tableNam]=$table;
			}
		}
		return $aTablesList;
		
		if(sizeof($this->aTables)>0)
			return $this->aTables;
		else
			return false;
	}
	
	# get table
	public function getTable($tableNam) {
		
		return (isset($this->aTables[$tableNam])? $this->$aTables[$tableNam]:array());
	}
	
	# set table
	public function setTable($tableNam,$a) {
		$this->aTables[$tableNam]=$a;
	}
	
	# read data of table
	public function loadData($table,$data_file_name='') {
		
		$dataformat = $this->aTables[$table]["dataformat"];
		//echo ("dataformat=".$dataformat);
		
		if ($data_file_name != ''){
			$xmldata= $data_file_name.".".$dataformat;
		}else{
			$xmldata= $table.".".$dataformat;
			$data_file_name=$table;
		}
		
		$s= $this->folder_data.$xmldata;
		if(!is_file($s)) return;

		if ($dataformat=="xml"){
			$atmp = spxdatasXmlmanager::loaddataxml($s);
		}else{
			$atmp = spxdatasJsonmanager::loaddatajson($s);
		}
		
		$this->aDatas[$data_file_name]=array();
		$this->aDatas[$data_file_name]=$atmp;
		return $atmp;
	}
	
	# for admin section liste
	public function getAdminData($table,$data_file_name='') {
		$_SESSION['spxdata']['table_name']=$table;
		
		if ($data_file_name != ''){
			$_SESSION['spxdata']['data_file_name']=$data_file_name;
		}else{
			$_SESSION['spxdata']['data_file_name']=$table;
			$data_file_name=$table;
		}
		
		
		# load all data needed (link table)
		for ($i=0;$i<count($this->aTables[$table]["column"]);$i++){
			$option = $this->aTables[$table]["column"][$i]["option"];
			if ($option[0]=="liste" || $option[0]=="checkboxliste" || $option[0]=="listeBuilderOption" || $option[0]=="checkboxlisteevolued" ){
				$tablesup = $option[1];
				$this->loadData($tablesup);
			}
		}
		# implanter l'html dans tmp
		$tmp = $this->loadData($table,$data_file_name);
		
		
		$afilter=array();
		# check user datauserlevel
		# check filter
		$count=1;
		
		if (is_array($this->aDatas[$data_file_name])){
			foreach($this->aDatas[$data_file_name] as $data) {
				
				$bdata_filter_include = true;
				for ($i=0;$i<count($this->aTables[$table]["column"]);$i++){
						$column = $this->aTables[$table]["column"][$i];
						$name = $this->aTables[$table]["column"][$i]["name"];
						$option = $column["option"];
						$value = $data["data"][$column["name"]]["value"];
						//if ($option[0]=="order"){
							//$this->aDatas[$table][$data["number"]]["data"][$column["name"]]["value"]=$count;
							//$this->aDatas[$table][$data["number"]]["print"]=$this->getHTMLfield($column,$count,$data["number"]);
						//}
						if ($option[0]=="liste"){
							$filter="filter_".$name;
							$filter_value_session=$_SESSION['spxdata']['filter'][$table][$name];
							if ($filter_value_session!=$value && $filter_value_session!="all" && $filter_value_session!=""){
									 $bdata_filter_include=false;
							}
						}
						
				}
				if ($bdata_filter_include == true) {
					$bcheckdatauser = false;
					if ($this->__getDataAutorized($table)){
						$bcheckdatauser = true;
					}else{
						if ($this->aDatas[$data_file_name][$data["number"]]["user"]==$_SESSION['user']){
							$bcheckdatauser = true;
						}
					}
					# check datauserlevel
					if ($bcheckdatauser) $afilter[$data["number"]] = $this->aDatas[$data_file_name][$data["number"]];
				}
				$count++;
			}
		}
		
		# check pager
		$out=array();
		$count=0;
		$page = $this->checkCurrentRecordPage($data_file_name,count($afilter));
		$startpage = $this->nb_data_pagination*($page-1);
		$endpage = $startpage + $this->nb_data_pagination-1;
		foreach($afilter as $data) {
			if ($count>=$startpage && $count<=$endpage){
				
				for ($i=0;$i<count($this->aTables[$table]["column"]);$i++){
					$column = $this->aTables[$table]["column"][$i];
					$option = $column["option"];
					$value = $data["data"][$column["name"]];
					
					$this->aDatas[$data_file_name][$data["number"]]["data"][$column["name"]]["print"]=$this->getHTMLfield($column,$value,$data["number"]);
					$out[$data["number"]] = $this->aDatas[$data_file_name][$data["number"]];
					
				}
			}
			$count++;
		}
		return $out;
	}

	# return a data array
	public function getAdminOneData($table,$data_id,$data_file_name='') {
		if ($data_id !=""){
			$dataliste = $this->getAdminData($table,$data_file_name);
			$data = $dataliste[$data_id];
		}else{
			$data=array();
			$dataliste = $this->getAdminData($table,$data_file_name);
			if ($data_file_name != ''){
				$data["number"]=$this->nextIdData($data_file_name);
			}else{
				$data["number"]=$this->nextIdData($table);
			}
			
			$data["data"]=array();
			for ($i=0;$i<count($this->aTables[$table]["column"]);$i++){
				$name = $this->aTables[$table]["column"][$i]["name"];
				$column = $this->aTables[$table]["column"][$i];
				$option = $column["option"];
				$value = "";
				$data["data"][$name]["value"]=$value;
				$data["data"][$name]["print"]=$this->getHTMLfield($column,$value,$data["number"]);
			}
		}
		return $data;
		
	}
	
	# return a html field
	public function getHTMLfield($acolumn,$avalue,$number_id) {	
		$aoption = $acolumn["option"];
		$name=$acolumn["name"];
		$reado=$acolumn["reado"];
		$value=$avalue["value"];
		$type = $aoption[0];
		
		switch ($type) {
		case "scandirliste":
			# image
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];	
			$filelib  = PLX_ROOT.$basepath_image;
			
			//directoryToArray($directory, $recursive = true, $listDirs = false, $listFiles = true, $exclude = '')
			if ($aoption[1]==""){
				$folder = $basepath_image;
			}else{
				$folder = "data/".$aoption[1];
			}
			
			$a = spxdatasUtils::directoryToArray(PLX_ROOT.$folder,"/",true,true,false,"/(^(([\.]){1,2})$|(.thumbs\.db|\.thumbs))$/iu");
			$out=array();
			for ($i=0;$i<count($a);$i++){
				$s= $a[$i]."/";
				$val=str_replace($filelib,"",$s);
				$out[$val] = $val;
			}
			return (spxdatasUtils::printSelect ($name.'[]', $out,$value,$reado));
		break;
		case "checkboxliste":
			$table = $aoption[1];
			$column = $aoption[2];
			$data = $this->aDatas[$table];
			return spxdatasUtils::get_checkboxliste($data,$column,$name,$value,$number_id);
		break;
		case "liste":
			$table = $aoption[1];
			$column = $aoption[2];
			$data = $this->aDatas[$table];
			$printarray = array();
			foreach($data as $val) {
				$valliste = $val["data"][$column]["value"];
				$idliste = $val["number"];
				$printarray[$idliste]=$valliste;
			}
			
			return (spxdatasUtils::printSelect ($name.'[]', $printarray,$value,$reado));
		break;
		case "fontawesomeIconPicker":
			$id = "id_".$name.$number_id;
			$afont = spxdatasUtils::getFontawesomelist ();
			$printarray = array();
			for ($i=0;$i<count($afont);$i++){
				$printarray[$afont[$i]]=$afont[$i];
			}
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").fontIconPicker();';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			return ($s.spxdatasUtils::printselectfontIconPicker ($name.'[]', $printarray,$value,$reado,'',true,$id));

		break;
		case "checkboxlisteevolued":
			
			$table = $aoption[1];
			$column = $aoption[2];
			$data = $this->aDatas[$table];
			return spxdatasUtils::get_checkboxlisteevolued($data,$aoption,$name,$value,$number_id);
			
		break;
		case "listestatic":
			$astatic = array();
			$plxMotor = plxMotor::getInstance();
			# On verifie qu'il y a des pages statiques
			if($plxMotor->aStats) {
				$group_name='';
				foreach($plxMotor->aStats as $k=>$v) {
					if($v['active'] == 1 AND $v['menu'] == 'oui') { # La page  est bien active et dispo ds le menu
						$idliste = $url;
						$astatic[''.$k]=$v['name'];
						
					}
				}
			}
			return (spxdatasUtils::printSelect ($name.'[]', $astatic,$value,$reado));
		break;
		case "listestaticandcat":
			$printarray = array();
			$astatic = array();
			$astaticgroup = array();
			$acategorie = array();
			$aarticlecategorie = array();
			$ahome = array();
			$plxMotor = plxMotor::getInstance();
			# On verifie qu'il y a des pages statiques
			if($plxMotor->aStats) {
				$group_name='';
				foreach($plxMotor->aStats as $k=>$v) {
					if($v['active'] == 1 AND $v['menu'] == 'oui') { # La page  est bien active et dispo ds le menu
						$idliste = $url;
						$astatic['static_'.$k]=$v['name'];
						
					}
				}
			}
			# Groupe de pages statiques
			if($plxMotor->aStats) {
				foreach($plxMotor->aStats as $k=>$v) {
					if($v['active'] == 1 AND $v['menu'] == 'oui') { # La page  est bien active et dispo ds le menu
						//$stat = str_replace('#static_id','static-'.intval($k),$format);
						//$stat = str_replace('#static_class','static-menu',$stat);
						
						if(!$v['group']=='') $astaticgroup['groupstatic_'.$v['group']]=  $v['group'];
					}
				}
			}
			
			# On verifie qu'il y a des categories
			if($plxMotor->aCats) {
				foreach($plxMotor->aCats as $k=>$v) {
					
						if(($v['articles']>0 OR $plxMotor->aConf['display_empty_cat']) AND ($v['menu']=='oui') AND $v['active']) { # On a des articles
							$acategorie['categorie_'.$k]=$v['name'];
							$aarticlecategorie['articlecategorie_'.$k]=$v['name'];
						}
					
				} # Fin du while
			}
			
			
			$ahome=array();
			$url = $plxMotor->urlRewrite();
			$ahome['cat_home']='Home';
			
			# ajout de other
			$aother["link_pluxml"]='Lien pluxml';
			$aother["link_external"]='Lien externe';
			$aother["link_externalblank"]='Lien externe(blank)';
			
			//$acategorie[$idliste]=$valliste;
			$printarray["Home"]=$ahome;
			$printarray["Pages statiques"]=$astatic;
			$printarray["Groupes pages statiques"]=$astaticgroup;
			$printarray["Categories"]=$acategorie;
			$printarray["Articles categories"]=$aarticlecategorie;
			$printarray["Autres Liens"]=$aother;
			
			return (spxdatasUtils::printSelect ($name.'[]', $printarray,$value,$reado));
			
		break;
	
		case "textarea":
			return (spxdatasUtils::printArea ($name.'[]', $value,$aoption[1],$aoption[2],$reado));
		break;	
		case "password":
		case "text":	
			return (spxdatasUtils::printInput ($name.'[]', $value, $type, $aoption[1]."-".$aoption[2],$reado));
		break;
		case "boolean":	
			return (spxdatasUtils::printSelect($name.'[]',array('1'=>L_YES,'0'=>L_NO),$value,$reado));
		break;
		case "booleanreverse":	
			if ($value=="") $value ="1";
			return (spxdatasUtils::printSelect($name.'[]',array('1'=>L_YES,'0'=>L_NO),$value,$reado));
		break;
		
		case "checkboxBoolean":
		case "checkboxBooleanreverse":
			
			$s=spxdatasUtils::get_checkboxBoolean($type,$name,$value,$number_id);
			
			return $s;
		break;
		
		case "sliderMinMax":
			$id = "id_".$name.$number_id;
			$min = $aoption[1];
			$max = $aoption[2];
			$default = $aoption[3];
			
			if (!$value) $value = $default;
			
			return spxdatasUtils::get_sliderMinMax($id,$name,$value,$min,$max);
		break;
		case "listnum":	
			$num1 = $aoption[1];
			$num2 = $aoption[2];
			$num = intval($num2) - intval($num1) ;
			$array = array();
			for ($i=0; $i<$num+1 ; $i++){
				$val = intval($num1)+$i;
				$array[$val]=$val;
			}
			
			return (spxdatasUtils::printSelect($name.'[]',$array,$value,$reado));
		break;
		
		case "imagepicker":
			$id = "id_".$name.$number_id;
			$plxMotor = plxMotor::getInstance();
			$filelib  = PLX_ROOT.$plxMotor->aConf['racine_themes'].$plxMotor->style;
			$subfile='/img/bg-pattern/';
			
			return spxdatasUtils::get_listeImagePicker($id,$name,$value,$filelib,$subfile);
		break;
		
		
		case "imagepickerThemesCurrentTheme":
			$id = "id_".$name.$number_id;
			$plxMotor = plxMotor::getInstance();
			$filelib  = PLX_ROOT.$plxMotor->aConf['racine_themes'].$plxMotor->style;
			
			$n = count ($aoption);
			$subfile ="";
			for ($i=1;$i<$n;$i++){
				$subfile.= "/".$aoption[$i];
			}
			$subfile=$subfile."/";
			
			return spxdatasUtils::get_listeImagePicker($id,$name,$value,$filelib,$subfile);
		break;
		
		case "imagepickerDataImages":
			$id = "id_".$name.$number_id;
			
			# image
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];	
			$filelib  = PLX_ROOT.$basepath_image;
			
			$n = count ($aoption);
			$subfile =$filelib;
			for ($i=1;$i<$n;$i++){
				$subfile.= "/".$aoption[$i];
			}
			$subfile=$subfile."/";
			
			return spxdatasUtils::get_listeImagePicker($id,$name,$value,$filelib,$subfile);
			
		break;
		
		case "imagepickerPlugin":
			$id = "id_".$name.$number_id;
			$plxMotor = plxMotor::getInstance();
			$filelib  = PLX_PLUGINS;
			
			$n = count ($aoption);
			$subfile ="";
			for ($i=1;$i<$n;$i++){
				$subfile.= "/".$aoption[$i];
			}
			$subfile=$subfile."/";
			return spxdatasUtils::get_listeImagePicker($id,$name,$value,$filelib,$subfile);
		break;
		
		case "spxdatasicongroup":
			$id = "id_".$name.$number_id;
			$filelib  = PLX_ROOT."plugins/spxdatas/img/";
			$subfile='icon/';
			return spxdatasUtils::get_listeImagePicker($id,$name,$value,$filelib,$subfile);
			
		break;
		case "colorpicker":	
			$id = "id_".$name.$number_id;
			if ($value=="") $value="ffffff";
			$s= spxdatasUtils::printInput2 ($id,$name."[]", $value, 'text', "10-10",$reado);
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").jPicker({
				
 				 window: // used to define the position of the popup window
          			// only useful in binded mode
  					{
				
				position:{x:"screenCenter",y:"center"} // 200 can be any fixed value
					}});';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			return $s;
		break;
		case "date":	
			$id = "id_".$name.$number_id;
			$s= spxdatasUtils::printInput2 ($id,$name."[]", $value, 'text', "10-10",$reado);
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").datepicker();';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			return $s;
		break;
		case "imageOLD":
			# image
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];	
			//$basepath_image = $plxAdmin->aConf['images'];
			
			$id = "id_".$name.$number_id;
			$s= spxdatasUtils::printInput2 ($id,$name."[]", $value, 'text', "30-100");
			$path = "../../plugins/spxdatas/medias.php?id=".$id;
			$s.='<a title="'.$this->getLang('L_CHOOSEIMAGELIB').'" id="toggler" href="javascript:void(0)" onclick=\'myVignette.openPopup("'.$path.'","undefined","750","580");return false;\' style="outline:none">';
			// 
			
			$image_path="../../".$basepath_image.$value;
			if ($value!="") {
				
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}else{
				$image_path=PLX_PLUGINS.'spxdatas/img/noimage.png';
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}
			
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").focus( function() {';
  				$s.="\n\t".'console.log ("ca marche  !!");';
				// check input ($(this).val()) for validity here
				$s.="\n\t".' var im= "../../'.$basepath_image.'"+$(this).val()';
				$s.="\n\t".'$("#img_'.$id.'").attr("src",im)';
			$s.=	"\n\t".'});';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			
			return $s;
		case "image":
			
			# image
			$plxAdmin =  plxAdmin::getInstance();
			$basepath_image = isset($plxAdmin->aConf['medias']) ? $plxAdmin->aConf['medias'] : $plxAdmin->aConf['images'];	
			//$basepath_image = $plxAdmin->aConf['images'];
			
			$id = "id_".$name.$number_id;
			$s= spxdatasUtils::printInput2 ($id,$name."[]", $value, 'text', "30-100");
			$path = "../../plugins/spxdatas/medias.php?id=".$id;
			
			
			$cibleId = $id;
			$replace = false;
			$fallback = "myfallback";
			
			$s.='<a title="'.$this->getLang('L_CHOOSEIMAGELIB').'" id="toggler" href="javascript:void(0)" onclick=\'mediasManager.openPopup("'.$cibleId.'","'.$replace.'","'.$fallback.'")\' style="outline:none">';
			
			$image_path="../../".$basepath_image.$value;
			if ($value!="") {
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}else{
				$image_path=PLX_PLUGINS.'spxdatas/img/noimage.png';
				$s.='<img id="img_'.$id.'" height="50" src="'.$image_path.'" class="thumb"></a>';
			}
			
			$s.="\n\t".'<script>';
			$s.="\n\t".'$(document).ready(function() {';
			$s.="\n\t".'$("#'.$id.'").focus( function() {';
				$s.="\n\t".'var val = $(this).val();';
				$s.="\n\t".'$(this).val(val.replace("'.$basepath_image.'", ""));';
				
  				$s.="\n\t".'console.log ("ca marche  !!");';
				// check input ($(this).val()) for validity here
				$s.="\n\t".' var im= "../../'.$basepath_image.'"+$(this).val();';
				$s.="\n\t".'$("#img_'.$id.'").attr("src",im);';
			$s.=	"\n\t".'});';
			$s.=	"\n\t".'});';
			$s.="\n\t".'</script>';
			
			
			return $s;
		break;
		case "icon":
			// newsletter_status
			$icon_status = $aoption[1];
			if ($value=="") $value=0;
			$s=spxdatasUtils::printInput ($name.'[]', $value, 'hidden', "10-20", true);
			$image_path=PLX_PLUGINS."spxdatas/img/".$icon_status."_".$value.".png";
			$s.='<img style="height:30px;vertical-align:top" src="'.$image_path.'" class="icon"></a>';
			return $s;
		break;
		case "listeUsers":
			return spxdatasUtils::get_listeUsers($name,$value);
		break;
		case "checkboxlisteUsersEvolued":
			return spxdatasUtils::get_checkboxlisteUsersEvolued($name,$value,$number_id);
			
		break;
		case "checkboxlisteAdmin":
			return spxdatasUtils::get_checkboxlisteadmin($name,$value,$number_id);
			
		break;
		case "listeBuilderOption":
			$table = $aoption[1];
			$column = $aoption[2];
			$data = $this->aDatas[$table];
			return spxdatasUtils::get_listeBuilderOption($data,$column,$name,$value);
		break;
		case "editstatic":
			$name = $aoption[1];
			return '<div align="left"><a href="plugin.php?p=spxdatas&page=static_edit&table='.$_SESSION['spxdata']['table_name'].'&data_id='.$number_id.'&name='.$name.'" title="'.$this->getLang('L_EDIT_PAGE_SOURCE').'">'.$this->getLang('L_EDIT').'</a></div >';
		break;
		case "listethemes":
			# On rcupre les templates
			$plxAdmin =   plxAdmin::getInstance();
			$aStyles[''] = L_NONE1;
			$files = plxGlob::getInstance(PLX_ROOT.$plxAdmin->aConf['racine_themes'], true);
			
			if($styles = $files->query("/[a-z0-9-_\.\(\)]+/i")) {
				foreach($styles as $k=>$v) {
					if(substr($v,0,7) != 'mobile.')	$aStyles[$v] = $v;
				}
			}
			return (spxdatasUtils::printSelect ($name.'[]', $aStyles,$value));
		break;
		case "subtable":
			$subtable = $aoption[1];
			$table = $_SESSION['spxdata']['table_name'];
			$url = $table.'.'.$number_id.".".$name.".".$subtable;
			$s=spxdatasUtils::printInput ($name.'[]', $url, 'hidden', "10-20", true);
			$s.='<div class="editsubtable" ></div ><a href="plugin.php?p=spxdatas&page=subdata_liste&subtable='.$url.'">'.$this->getLang('L_EDIT').'</a>';
			return $s;
		break;
		// use for menu hierarchy
		case "decal_h2":
			if ($value=="") $value="0";
			$s= '<img class="decal_h2" height="100%" style="margin-right:10px;margin-top:-7px;" src="'.PLX_PLUGINS.'spxdatas/img/decal'.$value.'.png" class="thumb">';
			return ($s.=spxdatasUtils::printInput ($name.'[]', $value, 'hidden','30-100',true,"decal_h2"));
		break;
		default:
			if ( $aoption[1]=="")  $aoption[1]=10;
			if ( $aoption[2]=="")  $aoption[2]=20;
			return (spxdatasUtils::printInput ($name.'[]', $value, 'text', $aoption[1]."-".$aoption[2],$reado));
			
		break;
		}
		
	}
	
	# get next id
	public function nextIdData($table) {
		if(is_array($this->aDatas[$table])) {
			$data = $this->aDatas[$table];
			$id=0;
			foreach($data as $val) {
				$id2 = intval($val["number"]);
				if ($id2>$id) $id=$id2;
			}
			return str_pad($id+1,3, '0', STR_PAD_LEFT);
		} else {
			return '001';
		}
	}
	
	# next id old
	public function nextIdDataOLD($table) {
		if(is_array($this->aDatas[$table])) {
			$idx = key(array_slice($this->aDatas[$table], -1, 1, true));
			return str_pad($idx+1,3, '0', STR_PAD_LEFT);
		} else {
			return '001';
		}
	}
	
	
	/* del a sub data */
	/*
	$o["table"]="spxwressources_plugins";
	$o["parent"]="spxwressources_author.002.plugins_content";
	$o["id"]="003";
	echo $plxShow->callHook('spxdatas::delSubData',$o);
	*/
	
	public function delSubData($o,$keepmode=false) {
		# keep mode admin to get data from site
		if ($keepmode==false) $this->setMode("admin");
		
		$content = array();
		$content["table_name"]= $o["table"];
		$data_file_name =$o["parent"].".".$o["table"];
		$content['selection']='delete';
		$content['idData']= array($o["id"]);
		$content["data_file_name"]=$data_file_name;
		
		$this->editDatas($content, true) ;
	}
	
	/* mod a sub data */
	/*
	$o["table"]="spxwressources_plugins";
	$o["parent"]="spxwressources_author.002.plugins_content";
	$o["id"]="002";
	$o["column"]=array("title");
	$o["value"]=array("test");
	echo $plxShow->callHook('spxdatas::setSubData',$o);
	*/
	public function setSubData($o,$keepmode=false) {
		
		# keep mode admin to get data from site
		if ($keepmode==false) $this->setMode("admin");
		
		# loading database
		$b = $this->loadTables();
		$tableliste = $this->getTables(false);
		
		$data_file_name =$o["parent"].".".$o["table"];
		
		if ($o["id"]==""){
			$this->loadData($o["parent"],$data_file_name);
			$nextid=$this->nextIdData($data_file_name);
			$id = $nextid;
			//$data = $this->getAdminOneData($o["table"],$o["id"],$data_file_name);
			//$id = $data["number"];
		}else{
			$id = $o["id"];
		}
		
		
		
		$ncolumn = count($tableliste[$o["table"]]["column"]);
		
		# output for post record
		$content=array();
		$content['update']=true;
		$content["table_name"]=$o["table"];
		# for subtable
		$content["data_file_name"]=$data_file_name;
		$content['data_num']=array();
		$content['data_num'][0]= $id;
		# find type with name
		$content['data_type']=array();
		$content['data_name']=array();
		$tmpvalue=array();
		$count=0;
		for ($i=0;$i<count($tableliste[$o["table"]]["column"]);$i++){
			$nameinbase = $tableliste[$o["table"]]["column"][$i]["name"];
			//
			for ($j=0;$j<count($o["column"]);$j++){
				if ($nameinbase == $o["column"][$j]){
					$content['data_type'][$count] = $tableliste[$o["table"]]["column"][$i]["type"];
					$content['data_name'][$count] = $nameinbase;
					$tmpvalue[$count]=$o["value"][$j];
					$count++;
					break;
				}
				
			}
		}
		
		# send value
		for ($i=0;$i<count($content['data_name']);$i++){
			$namecol = $content['data_name'][$i];
			$val = $o["value"][$i];
			$content[$namecol]=array();
			$content[$namecol][0] = $tmpvalue[$i];
		}
		
		// record
		$this->editDatas($content, true) ;
		
	}
	
	
	
	# from client site delete
	/*
	$o=array();
	$o["table"]="newsletter";
	$o["id"]=$id;
	$plxPlugin->delData($o,true);
	*/
	public function delData($o,$keepmode=false) {
		# keep mode admin to get data from site
		if ($keepmode==false) $this->setMode("admin");
		
		$content = array();
		$content["table_name"]= $o["table"];
		$content["data_file_name"]=$o["table"];
		$content['selection']='delete';
		$content['idData']= array($o["id"]);
		
		$this->editDatas($content, true) ;
	}
	
	
	# from client site record d'une ligne
	/*// update icon status
		$o=array();
		$o["table"]="newsletter";
		$o["id"]=$mastertableID;
		$o["column"]=array("status");
		$o["value"]=array("1");
		
		$plxPlugin->setData($orecord,true);
        
        
        
        $o=array();
		$o["table"]="newsletter_mail";
		$o["id"]="";
		$o["column"]=array("mail","group");
		$o["value"]=array($email,$group_id);

		$a = $plxShow->callHook('spxdatas::setData',$o);*/
		
	public function setData($o,$keepmode=false) {
		
		# keep mode admin to get data from site
		if ($keepmode==false) $this->setMode("admin");
		
		/*
		$o=array();
		$o["table"]="newsletter_mail";
		$o["id"]="";
		$o["column"]=array("mail","group");
		$o["value"]=array("gg@prout55.fr","001");*/
		
		//print_r($o);
		
		// post avant record d'une nouvelle entre ou pas fonction du data_num si il existe ou pas
		/* 

		
		1 entree
		
				Array
		(
			[data_num] => Array
				(
					[0] => 001
				)
		
			[choose_table] => newsletter_mail
			[data_name] => Array
				(
					[0] => mail
					[1] => group
				)
		
			[data_type] => Array
				(
					[0] => cdata
					[1] => cdata
				)
		
			[mail] => Array
				(
					[0] => je-evrard@neuf.fr
				)
		
			[group] => Array
				(
					[0] => 001
				)
		
			[token] => 83caa5f8bec0d9b815e78af4b6a94d2238d63f2f
			[update] => Enregistrer
		)
		*/
		/*  3 entree
				
				Array
		(
			[choose_table] => newsletter_mail
			[data_type] => Array
				(
					[0] => cdata
					[1] => cdata
				)
		
			[data_name] => Array
				(
					[0] => mail
					[1] => group
				)
		
			[filter_group] => all
			[data_num] => Array
				(
					[0] => 001
					[1] => 002
					[2] => 003
				)
		
			[mail] => Array
				(
					[0] => je-evrard@neuf.fr
					[1] => evrard.je@gmail.com
					[2] => tot@kk.fr
				)
		
			[group] => Array
				(
					[0] => 001
					[1] => 002
					[2] => 001
				)
		
			[token] => a767188d60ddd465ea250198401cbadbd5c34099
			[update] => Modifier la liste des donnes
			[selection] => 
		)
		*/
		
		
		# loading database
		$b = $this->loadTables();
		
		$tableliste = $this->getTables();
		
		if ($o["id"]==""){
			$this->loadData($o["table"]);
			$nextid=$this->nextIdData($o["table"]);
			$id = $nextid;
		}else{
			$id = $o["id"];
		}
		
		$ncolumn = count($tableliste[$o["table"]]["column"]);
		
		# output for post record
		$content=array();
		$content['update']=true;
		$content["table_name"]=$o["table"];
		# for subtable
		$content["data_file_name"]=$o["table"];
		$content['data_num']=array();
		$content['data_num'][0]= $id;
		
		// find type with name
		$content['data_type']=array();
		$content['data_name']=array();
		$tmpvalue=array();
		$count=0;
		for ($i=0;$i<count($tableliste[$o["table"]]["column"]);$i++){
			$nameinbase = $tableliste[$o["table"]]["column"][$i]["name"];
			//
			for ($j=0;$j<count($o["column"]);$j++){
				if ($nameinbase == $o["column"][$j]){
					$content['data_type'][$count] = $tableliste[$o["table"]]["column"][$i]["type"];
					$content['data_name'][$count] = $nameinbase;
					$tmpvalue[$count]=$o["value"][$j];
					$count++;
					break;
				}
				
			}
		}
		
		# send value
		for ($i=0;$i<count($content['data_name']);$i++){
			$namecol = $content['data_name'][$i];
			$val = $o["value"][$i];
			$content[$namecol]=array();
			$content[$namecol][0] = $tmpvalue[$i];
		}
		
		// record
		$this->editDatas($content, true) ;
		
	}
	# from post datas list or detail
	public function editDatas($content, $action=false) {
		$this->__clearCache();
		
		$aidupdated = array();
		$choose_table=$content["table_name"];
		$data_file_name=$content["data_file_name"];
		
		$this->loadTables($this->file_table);
		
		$dataformat = $this->aTables[$choose_table]["dataformat"];
		//echo ("data format = ".$dataformat);
		$xmldata= $content["data_file_name"].".".$dataformat;
		$this->loadData($content["table_name"],$content["data_file_name"]);
		$pathdata = $this->folder_data.$xmldata;
		$this->checkAdminFilter($content);
		
		# suppression
		if(!empty($content['selection']) AND $content['selection']=='delete' AND isset($content['idData'])) {
			//echo ("suppression");
			foreach($content['idData'] as $data_id) {
				unset($this->aDatas[$data_file_name][$data_id]);
				$action = true;
			}
		}
		# mise  jour de la liste des data
		elseif(!empty($content['update']) || !empty($content['update_and_actions'])) {
			# mettre a jour que les donnes du post
			$count=0;
			foreach($content['data_num'] as $data_id) {
				# nouvelle entre
				if ($this->aDatas[$data_file_name][$data_id]==""){
						//echo ("nouvelle entree".$data_file_name.$data_id);
						$this->aDatas[$data_file_name][$data_id]=array();
						$this->aDatas[$data_file_name][$data_id]["number"]=$data_id;
						$this->aDatas[$data_file_name][$data_id]["user"]=$_SESSION['user'];
						$this->aDatas[$data_file_name][$data_id]["order"]=intval($data_id);
						$this->aDatas[$data_file_name][$data_id]["data"]=array();
						for($i=0;$i<count($content['data_name']);$i++) {
							$name= $content['data_name'][$i];
							$type= $content['data_type'][$i];

							# $value = $content[$name][$count];
							# checkboxlist check id id ...
							if(!empty($content[$name.$data_id])) {
								$s="";
								
								foreach($content[$name.$data_id] as $check) {
									// record only if id (no selection bug)
									if ($check != "none") {
										$s.=$check." ";
									}
								}
								$s = substr($s, 0, -1);
								$value = $s;
							}else{
								$value = $content[$name][$count];
							}
							
							$this->aDatas[$data_file_name][$data_id]["data"][$name]=array();
							$this->aDatas[$data_file_name][$data_id]["data"][$name]["name"]=$name;
							$this->aDatas[$data_file_name][$data_id]["data"][$name]["type"]=$type;
							if ($type=="numeric") $value = intval($value);
							$this->aDatas[$data_file_name][$data_id]["data"][$name]["value"]=$value;
						}
						
						# traitement de l'action pour une nouvelle entre
						array_push ($aidupdated, $data_id);
				# update		
				}else{
					# order
					if ($content["order"][$count]==""){
						 $order = intval($data_id);
					}else{
						 $order = intval($content["order"][$count]);
					}
					$this->aDatas[$data_file_name][$data_id]["order"]=$order;
					for($i=0;$i<count($content['data_name']);$i++) {
						$name= $content['data_name'][$i];
						$type= $content['data_type'][$i];
						
							# check checkbox category001[]
							if(!empty($content[$name.$data_id])) {
								$s="";
								foreach($content[$name.$data_id] as $check) {
									if ($check != "none") {
										$s.=$check." ";
									}
								}
								$s = substr($s, 0, -1);
								//echo "code : ",$s,"<br>";
								$value = $s;
							}else{
								$value = $content[$name][$count];
							}
							
						$this->aDatas[$data_file_name][$data_id]["data"][$name]=array();
						$this->aDatas[$data_file_name][$data_id]["data"][$name]["name"]=$name;
						$this->aDatas[$data_file_name][$data_id]["data"][$name]["type"]=$type;
						if ($type=="numeric") $value = intval($value);
						$this->aDatas[$data_file_name][$data_id]["data"][$name]["value"]=$value;
					}
					# traitement de l'action pour un update entre
					array_push ($aidupdated, $data_id);
					$count++;
				}
			}
			$action = true;
			
		}
		
		# order
		if(sizeof($this->aDatas[$data_file_name])>0) uasort($this->aDatas[$data_file_name], create_function('$a, $b', 'return $a["order"]>$b["order"];'));
	
		
		
		# sauvegarde
		if($action) {
			
			if ($dataformat=="json"){
				$bwrite = spxdatasJsonmanager::savedatajson($pathdata, $this->aDatas[$data_file_name]);
			}else{
				$bwrite = spxdatasXmlmanager::savedataxml($pathdata, $this->aDatas[$data_file_name]);
			}
			
			# On crit le fichier
			if($bwrite) {
				if(!empty($content['update_and_actions'])) spxdatasActions::checkaction($content,$choose_table, $aidupdated);
				# cot client ou cot admin ?
				if(defined('PLX_ADMIN')) {
					return plxMsg::Info(L_SAVE_SUCCESSFUL);
				}
			} else {
				//$this->aCats = $save;
				//return plxMsg::Error(L_SAVE_ERR.' '.PLX_ROOT.$this->aConf['categories']);
			}
		}
	}
	
	# get base content
	public function getBaseContent($basename="") {
		# Emplacement de la page
		if ($basename=="") $basename = $this->getParam('file_table');
		$basephp= "/".$basename.".php";
		$filename=$this->getPathTable().$basephp;
		if(file_exists($filename) AND filesize($filename) > 0) {
			if($f = fopen($filename, 'r')) {
				$content = fread($f, filesize($filename));
				fclose($f);
				# On retourne le contenu
				return $content;
			}
		}
		return null;
	}
	
	
	
	/*
	public function getPathBuilderDatas() {
		return $this->file_spxdatas."builderdata/";
	}
	public function getPathTable() {
		return $this->file_spxdatas."table/";
	}
	public function getPathData() {
		return $this->file_spxdatas."data/";
	}
	*/
	
	# get base folder use by base_edit.php
	/*
	public function getBaseFolder() {
		return $this->file_spxdatas."table/";
	}
	*/
	
	# with id from post base write in php file
	public function editBase($content) {
		$this->__clearCache();

		$basephp= "/".$content['basename_select'].".php";
		$filename=$this->getPathTable().$basephp;
		
		# On crit le fichier
			if(plxUtils::write($content['basecontent'],$filename))
				return plxMsg::Info(L_SAVE_SUCCESSFUL);
			else
				return plxMsg::Error(L_SAVE_ERR.' '.$filename);
	}
	
	# del base file (impossible de supprimer la current base file)
	public function delBaseFile($basename) {
		$filename=$this->getPathTable().$basename.".php";
		if ($basename == $this->getParam('file_table')){
			return plxMsg::Error(L_PLXMEDIAS_DELETE_FILE_ERR.' '.$filename);
		}else{
			if(spxdatasUtils::deleteFile($filename))
				return plxMsg::Info(L_PLXMEDIAS_DELETE_FILE_SUCCESSFUL);
			else
				return plxMsg::Error(L_PLXMEDIAS_DELETE_FILE_ERR.' '.$filename);
		}
	}
	
	# get static content
	public function getStaticContent($table,$data_id,$name) {
		$filename=$this->folder_data.$table.".".$data_id.".".$name.".php";
		if(file_exists($filename) AND filesize($filename) > 0) {
			if($f = fopen($filename, 'r')) {
				$content = fread($f, filesize($filename));
				fclose($f);
				# On retourne le contenu
				return $content;
			}
		}
		return null;
	}
	
	# with id from post static write in php file
	public function editStatic($content) {
		$table=$content['table'];
		$data_id=$content['data_id'];
		$name=$content['name'];
		$filename=$this->folder_data.$table.".".$data_id.".".$name.".php";
		# On crit le fichier
			if(plxUtils::write($content['staticcontent'],$filename))
				return plxMsg::Info(L_SAVE_SUCCESSFUL);
			else
				return plxMsg::Error(L_SAVE_ERR.' '.$filename);
	}
	
	# use tinymce or not
	public function useTinymce() {
		$b=$this->getParam('btinymce');
		if ($b!="1") return false;
		return true;
	}
	
	/* //////////////////PRIVATE////////////////////////*/
	
	private  function __getTableAutorized($table) {
		if(defined('PLX_ADMIN')) {
			$b=false;
			$id_user = $_SESSION['user'];
			# 0 to 4
			$level_user = $_SESSION['profil'];
			$auserlevel= $this->aTables[$table]["user"]["tableuserlevel"];
			$auserinclude=$this->aTables[$table]["user"]["tableuserinclude"];
			$auserexclude=$this->aTables[$table]["user"]["tableuserexclude"];
		
			for ($i=0;$i<count($auserlevel);$i++){
				if ($level_user == $auserlevel[$i]) $b=true;
			}
			
			for ($i=0;$i<count($auserinclude);$i++){
				if ($id_user == $auserinclude[$i]) $b=true;
			}
			
			for ($i=0;$i<count($auserexclude);$i++){
				if ($id_user == $auserexclude[$i]) $b=false;
			}
			
			return $b;
		}else{
			return true;	
		}
	}
	
	private  function __getDataAutorized($table) {
		$b=false;
		$id_user = $_SESSION['user'];
		# 0 to 4
		$level_user = $_SESSION['profil'];
		$auserlevel= $this->aTables[$table]["user"]["datauserlevel"];
		$auserinclude=$this->aTables[$table]["user"]["datauserinclude"];
		$auserexclude=$this->aTables[$table]["user"]["datauserexclude"];
		for ($i=0;$i<count($auserlevel);$i++){
			if ($level_user == $auserlevel[$i]) $b=true;
		}
		for ($i=0;$i<count($auserinclude);$i++){
			if ($id_user == $auserinclude[$i]) $b=true;
		}
		for ($i=0;$i<count($auserexclude);$i++){
			if ($id_user == $auserexclude[$i]) $b=false;
		}
		return $b;
	}
	private  function __getCMD($table) {
		$cmd="111";
		$id_user = $_SESSION['user'];
		# 0 to 4
		$level_user = $_SESSION['profil'];
		$arightCMDlevel=$this->aTables[$table]["user"]["rightCMDlevel"];
		$arightCMDuser=$this->aTables[$table]["user"]["rightCMDuser"];
		
		for ($i=0;$i<count($arightCMDlevel);$i++){
			# 4:010
			$atmp = explode (":",$arightCMDlevel[$i]);
			if ($atmp[0] == $level_user) $cmd=$atmp[1];
		}
		for ($i=0;$i<count($arightCMDuser);$i++){
			# 004:010
			$atmp = explode (":",$arightCMDuser[$i]);
			if ($atmp[0] == $id_user) $cmd=$atmp[1];
		}
		
		$acmd = array();
		$acmd["C"]=$cmd[0];
		$acmd["M"]=$cmd[1];
		$acmd["D"]=$cmd[2];

		return $acmd;
	}
	
	# table : "auteur"
	# field not use at this step
	# filter  type=1 and type2=2  $afilter["type"]="1"; ?? plutot auteur.type=1 and auteur.type2=2 afilter["table"]["type"]="1"
	# order si vide liste admin par default ascendant
	# limit = n OK
	# out : html or array ok
	# format ok
	# $o["subtable_format"][$table][$name]
	private  function __getData($o) {
		# check variable
		if ($o["table"]==""){
			return false;
		}else{
			$table=	$o["table"];
		}
		if ($o["field"]==""){
			$field="";
		}	
		if ($o["filter"]==""){
			$afilter="";
		}else{
			$afilter=array();
			$filter=$o["filter"];
			# $filer = "field1=valeur and ..."
			$tmp=explode(" and ",$filter);
			
			for ($i=0;$i<count($tmp);$i++){
				$tmp2=explode("=",$tmp[$i]);
				$s = $tmp2[0];
				$afilter[$s]=$tmp2[1];
			}
		}
		
		# $order="name|D" or $order="name|A" or $order="name"
		if ($o["order"]==""){
			$order="";
			# $sortS='name';
			# $sortO=SORT_DESC;
		}else{
			$order = $o["order"];
			$aorder = explode("|",$order);
			$sortS=$aorder[0];
			$sortO="";
			if ($aorder[1]=="D"){
				$sortO=SORT_DESC;
			}else{
				$sortO=SORT_ASC;
			}
			
		}
		
		# LIMIT 10 OFFSET 10	
		if ($o["limit"]==""){
			$limit=99999999;
		}else{
			$limit = $o["limit"];
		}
		// offset
		if ($o["offset"]==""){
			$offset=0;
		}else{
			$offset = $o["offset"];
		}
		# out
		if ($o["out"]=="array" || $o["out"]=="array_asso"){
			$out="array";
			$format="";
		}else{
			if ($o["format"]==""){
				$out="array";
				$format="";
			}else{
				if ($o["out"]=="array_html") {
					$out=$o["out"];
				}else{
					$out="html";
				}
				
				$format = $o["format"];	
			}
		}
		
		# load all data needed (link table)
		$this->loadTables($this->file_table);
		$this->loadData($table);
		for ($i=0;$i<count($this->aTables[$table]["column"]);$i++){
			$option = $this->aTables[$table]["column"][$i]["option"];
			if ($option[0]=="liste" ){
				$tablesup = $option[1];
				$this->loadData($tablesup);
			}
		}
		
		# check data
		$dataliste = $this->aDatas[$table];
		$atmp = array();
		$ncolumn = count($this->aTables[$table]["column"]);
		$count;
		foreach($dataliste as $data){
			$atmp2=array();
			$include = true;
			for($i=0; $i<$ncolumn; $i++) {					
				$name = $this->aTables[$table]["column"][$i]["name"];
				$type =$this->aTables[$table]["column"][$i]["type"];
				$value = $data["data"][$name]["value"];
				$atmp2[$name]=$value;
				
				# check filter
				if ($afilter!="" && $afilter[$name]!=""){
					if ($afilter[$name]!=$value) $include = false;
			
				}
				
			}
			if ($afilter!="" && $afilter[$table."_id"]!=""){
				if ($afilter[$table."_id"]!=$data["number"]) $include=false;
			}
			
			# filter id special
			if ($include==true){
				$atmp2[$table."_id"]=$data["number"];
				array_push($atmp,$atmp2);
			}
			
			$count++;
			if ($count>=$limit) break;
		}
		# $offset (begin)
		$atmp2=array();
		$atmp2=$atmp;
		$atmp=array();
		for ($i=$offset;$i<count($atmp2);$i++){
			array_push($atmp,$atmp2[$i]);
		}
		
		if ($order != ""){
			$atmp3= array();
			for ($i=0;$i<count($atmp);$i++){
				$atmp3["id".$i]=array();
				$atmp3["id".$i]=$atmp[$i];
			}
			$atmp3 = $this->__array_sort($atmp3,$sortS,$sortO);
			$count=0;
			foreach ($atmp3 as $k => $v) {
				$atmp[$count]=$v;
				$count++;
			}
		}
		# check sub table
		
		for ($i=0;$i<count($atmp);$i++){
				for($j=0; $j<$ncolumn; $j++) {
					//$type =$this->aTables[$table]["column"][$j]["type"];
					$name = $this->aTables[$table]["column"][$j]["name"];
					$option = $this->aTables[$table]["column"][$j]["option"];
					if ($option[0]=="subtable" ){
						
						// $subtable = $option[1];
						$osubtable=array();
						$osubtable["url"]=$atmp[$i][$name];
						
						$osubtable["out"]=$out;
						$osubtable["format"]=$o["subtable_format"][$name];
						$atmp[$i][$name] = $this->__getDataSubtable($osubtable);
					}
				}
		}
		
		# out html
		if ($format !=""){
			$shtml = "";
			for ($i=0;$i<count($atmp);$i++){
				$shtmltmp = $format;
				for($j=0; $j<$ncolumn; $j++) {					
					$name = $this->aTables[$table]["column"][$j]["name"];
					$type =$this->aTables[$table]["column"][$j]["type"];
					$value = $atmp[$i][$name];
					$shtmltmp = str_replace('#'.$name,$value,$shtmltmp);
				}
				// add id
				
				$value = $atmp[$i][$table."_id"];
				$shtmltmp = str_replace('#'.$table."_id",$value,$shtmltmp);
				
				$atmp[$i]["display_html"]=$shtmltmp;
				$shtml.= $shtmltmp;
				
			}
			if ($out =="array_html"){
				return $atmp;
			}else{
				return $shtml;
			} 
			
		}else{
			if ($o["out"]=="array_asso"){
				$atmp2= array();
				$asso = $table."_id";
				for($i=0; $i<count($atmp); $i++) {	
					$id = $atmp[$i][$asso];
					$atmp2[$id]=$atmp[$i];
				}
				return $atmp2;
			}
			
			return $atmp;
		}
	}
	
	public  function __getDataSubtable($o) {
		
		/*
		$o["url"]
		$o["limit"]
		$o["offset"]
		$o["out"]
		$o["format"]
		*/
		
		$ainfos = explode (".",$o["url"]);
		$o["table"]=$ainfos [0];
		$o["table_data_id"]=$ainfos [1];
		$o["column_name"]=$ainfos [2];
		$o["subtable"]=$ainfos [3];
		
		
		
		# LIMIT 10 OFFSET 10	
		if ($o["limit"]==""){
			$limit=99999999;
		}else{
			$limit = $o["limit"];
		}
		// offset
		if ($o["offset"]==""){
			$offset=0;
		}else{
			$offset = $o["offset"];
		}
		
		# out
		if ($o["out"]=="array" || $o["out"]=="array_asso"){
			$out="array";
			$format="";
		}else{
			if ($o["format"]==""){
				$out="array";
				$format="";
			}else{
				if ($o["out"]=="array_html") {
					$out=$o["out"];
				}else{
					$out="html";
				}
				
				$format = $o["format"];	
			}
		}

		$subtable = $o["subtable"];
		$data_file_name = $o["url"];
		# check variable
		if ($o["subtable"]==""){
			return false;
		}else{
			$subtable=	$o["subtable"];
		}
		
		# load all data needed (link table)
		$this->loadTables($this->file_table);
		$this->loadData($subtable,$data_file_name);
		
		# check data
		$dataliste = $this->aDatas[$data_file_name];
		$atmp = array();
		$ncolumn = count($this->aTables[$subtable]["column"]);
		$count;
		if (is_array($dataliste)){
			foreach($dataliste as $data){
				$atmp2=array();
				$include = true;
				for($i=0; $i<$ncolumn; $i++) {					
					$name = $this->aTables[$subtable]["column"][$i]["name"];
					$type =$this->aTables[$subtable]["column"][$i]["type"];
					$value = $data["data"][$name]["value"];
					$atmp2[$name]=$value;
				}
				
				# filter id special
				if ($include==true){
					$atmp2[$subtable."_id"]=$data["number"];
					array_push($atmp,$atmp2);
				}		
			}
		}
		
		# out html
		if ($format !=""){
			$shtml = "";
			for ($i=0;$i<count($atmp);$i++){
				$shtmltmp = $format;
				for($j=0; $j<$ncolumn; $j++) {					
					$name = $this->aTables[$subtable]["column"][$j]["name"];
					$type = $this->aTables[$subtable]["column"][$j]["type"];
					$value = $atmp[$i][$name];
					$shtmltmp = str_replace('#'.$name,$value,$shtmltmp);
				}
				// add id
				
				$value = $atmp[$i][$subtable."_id"];
				$shtmltmp = str_replace('#'.$subtable."_id",$value,$shtmltmp);
				
				$atmp[$i]["display_html"]=$shtmltmp;
				$shtml.= $shtmltmp;
				
			}
			if ($out =="array_html"){
				return $atmp;
			}else{
				return $shtml;
			} 
			
		}else{
			if ($o["out"]=="array_asso"){
				$atmp2= array();
				$asso =$subtable."_id";
				for($i=0; $i<count($atmp); $i++) {	
					$id = $atmp[$i][$asso];
					$atmp2[$id]=$atmp[$i];
				}
				return $atmp2;
			}
			
			return $atmp;
		}
		
	}

	# generic sort
	private function __array_sort($array, $on, $order=SORT_ASC){
		$new_array = array();
		$sortable_array = array();
	
		if (count($array) > 0) {
			foreach ($array as $k => $v) {
				if (is_array($v)) {
					foreach ($v as $k2 => $v2) {
						if ($k2 == $on) {
							$sortable_array[$k] = $v2;
						}
					}
				} else {
					$sortable_array[$k] = $v;
				}
			}
	
			switch ($order) {
				case SORT_ASC:
					asort($sortable_array);
				break;
				case SORT_DESC:
					arsort($sortable_array);
				break;
			}
	
			foreach ($sortable_array as $k => $v) {
				$new_array[$k] = $array[$k];
			}
		}
	
		return $new_array;
	}
	
	# redefined data folder if multilingue
	private  function __checkmultilingue() {
		//global $plxShow;
		//var_dump ($plxShow->plxMotor->plxPlugins->aPlugins['plxMyMultiLingue']['instance']);
		//var_dump ($plxShow->plxMotor->plxPlugins);
		/*		$plxMotor = plxMotor::getInstance();
		$b = $plxMotor->plxPlugins->aPlugins['plxMyMultiLingue']["activate"];
		if ($b==true){
		echo ("actif");
		}else{
			echo ("non actif");
			
		}
		*/
		
		//print_r ($result);
		//echo ($result);
		
		# check lang
		$lang='';
		if(defined('PLX_ADMIN')){
			if (plxUtils::getValue($_SESSION['plxMyMultiLingue'])==''){
				if (plxUtils::getValue($_COOKIE['plxMyMultiLingue'])!='') {
					$lang=$_COOKIE['plxMyMultiLingue'];
				}
			}else {
				$lang=$_SESSION['plxMyMultiLingue'];
			}
		}else{
			if (plxUtils::getValue($_COOKIE['plxMyMultiLingue'])!='') {
				$lang=$_COOKIE['plxMyMultiLingue'];
			}
		}
		# check de la lang
		
		if ($lang !=''){
			// check folder
			if(!is_dir($this->folder_data.$lang)) mkdir($this->folder_data.$lang, 0755, true);
			$this->folder_data = $this->folder_data.$lang."/";
		}
		
		
		//echo ("------------lang-----------".$lang);
		//echo ("------------admin session multi-----------".$_SESSION["plxMyMultiLingue"]);
		//echo ("------------site cokiee multi-----------".$_COOKIE["plxMyMultiLingue"]);
		
	}
	
	# redefined data folder if multilingue
	private  function __cfixsecurity($path) {
		$htaccess = '<Files *>
   		 Order allow,deny
   		 Deny from all
		</Files>';
		//$path = '/path/';
		
		if ( !file_exists($path.'.htaccess') ){
			file_put_contents( $path.'.htaccess', $htaccess );
		}
		
	}
	
	# need cache
	private  function __checkCacheNeeded($o) {
		$smd5= md5(serialize($o));
		if (!empty($_SESSION['spxdata']['cache'][$smd5])){
			return $_SESSION['spxdata']['cache'][$smd5];
		}else{
			$ret = $this->__getData($o);
			$_SESSION['spxdata']['cache'][$smd5]=$ret;
			return $ret;
		}	
	}
	
	# clear cache after admin change or base
	private  function __clearCache() {
		$_SESSION['spxdata']['cache']=array();
	}
	
	# add jquery jqery ui and tynimce
	public function addJSlibrairy() {
		//p=spxdatas
		if ($this->useTinymce()==true){
			echo "\n".'
			<script type="text/javascript" src="'.PLX_PLUGINS.'spxdatas/assets/tinymce/tinymce.min.js"></script>
			<link rel="stylesheet" href="'.PLX_PLUGINS.'spxdatas/assets/tinymce/skins/lightgray/skin.min.css">';
       }
        
        
		echo "\n".'
		<script type="text/javascript">
		/* <![CDATA[ */
		!window.jQuery && document.write(\'<script  type="text/javascript" src="'.PLX_PLUGINS.'spxdatas/assets/jquery/jquery-1.8.3.min.js"><\/script>\');
		/* !]]> */
		</script>
		<link rel="stylesheet" href="'.PLX_PLUGINS.'spxdatas/assets/jquery-ui-1.9.2/css/jquery-ui.1.9.2.css">
		<script type="text/javascript" src="'.PLX_PLUGINS.'spxdatas/assets/jquery-ui-1.9.2/js/jquery-ui.js"></script>
		
		
		
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/jPicker/css/jpicker-1.1.6.min.css" />
		
  		<script src="'.PLX_PLUGINS.'spxdatas/assets/jPicker/jpicker-1.1.6.js" type="text/javascript"></script>
		
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/image-picker/image-picker.css" />
		
		<script src="'.PLX_PLUGINS.'spxdatas/assets/image-picker/image-picker.min.js" type="text/javascript"></script>
		
		
		<script src="'.PLX_PLUGINS.'spxdatas/assets/masonry/masonry.pkgd.min.js" type="text/javascript"></script>
		
		<script src="'.PLX_PLUGINS.'spxdatas/assets/imagesloaded/imagesloaded.pkgd.min.js" type="text/javascript"></script>
		
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/jquery-switchbutton/jquery.switchButton.css" />
		<script src="'.PLX_PLUGINS.'spxdatas/assets/jquery-switchbutton/jquery.switchButton.js" type="text/javascript"></script>
		
		
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/fonticonpicker/css/jquery.fonticonpicker.min.css" />
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/fonticonpicker/css/jquery.fonticonpicker.grey.min.css" />
		<link rel="Stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxdatas/assets/fonticonpicker/font-awesome-4.0.3/css/font-awesome.css" />
		
		<script src="'.PLX_PLUGINS.'spxdatas/assets/fonticonpicker/jquery.fonticonpicker.min.js" type="text/javascript"></script>
		
		';
		
		
	}
	
	# Mthode qui charge le fichier de langue par dfaut du builder
	private function loadLangAdmin() {
		$plxAdmin =  plxAdmin::getInstance();
		$this->aLangAdmin=array();
		$mylang = isset($_SESSION['lang']) ? $_SESSION['lang'] : $plxAdmin->aConf['default_lang'];
		if ($mylang!="fr") $mylang="en";
		
		if ($_SESSION['spxdata']['adminmode']=="builder"){
			$filename = PLX_ROOT."plugins/spxdatas/builder/buildertable/builder_loc/".$mylang."/admin.php";
		}else{
			$filename = $this->folder_table.$this->getParam('file_table')."_loc/".$mylang."/admin.php";
			//echo("filename=".$filename);
			//if(!is_dir($folder)) mkdir($folder, 0755, true);
		}
		
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		$LANG = $this->addons_loc_plugins($LANG,$mylang);
		$this->aLangAdmin=$LANG;
	}
	
	public function get_loc_admin($what,$code,$code2="") {
		switch ($what) {
			case "groupe_title":
				$loc = $this->aLangAdmin["L_GROUPE_".strtoupper($code)."_TITLE"];
				if ($loc=="") $loc=$code;
			break;
			case "table_title":
				$loc = $this->aLangAdmin["L_TABLE_".strtoupper($code)."_TITLE"];
				if ($loc=="") $loc=$code;	
			break;
			case "table_description":
				// table description xml
				$loc = $this->aLangAdmin["L_TABLE_".strtoupper($code)."_DESCRIPTION"];	
				if ($loc== "" || $loc=="<p></p>") $loc =$code2;
			break;
			case "action_title":
				$loc = $this->aLangAdmin["L_TABLE_".strtoupper($code)."_ACTIONTITLE"];	
				if ($loc== "" || $loc=="<p></p>") $loc =$code2;
			break;
			case "column_highlight_title":
				// table column
				$loc = $this->aLangAdmin["L_TABLE_COLUMN_".strtoupper($code)."_".strtoupper($code2)."_HIGHLIGHTTITLE"];
				if ($loc!= "" && $loc!="<p></p>") {
					$loc ='<div class="highlight"><h4>'.$loc.'</h4></div>';
				}else{
					$loc ="";
				}
			break;
			
			case "column_title":
				// table column
				$loc = $this->aLangAdmin["L_TABLE_COLUMN_".strtoupper($code)."_".strtoupper($code2)."_TITLE"];
				if ($loc== "") $loc =$code2;
			break;
			case "column_help":
				$loc = $this->aLangAdmin["L_TABLE_COLUMN_".strtoupper($code)."_".strtoupper($code2)."_HELP"];
				if ($loc!= "" && $loc!="<p></p>") {
					$loc ='&nbsp;<a class="help" title="'.$loc.'">&nbsp;</a>';
				}else{
					$loc ='';
				}
			
			break;
			default:
				return $code;
			break;
		}
		
		
		return $loc;
		
	}
	# fonction de chargement d'un fichier de langue
	/*
	private  function loadLangBuilder($filename) {
		if(file_exists($filename)) {
			$LANG = array();
			include_once($filename);
			foreach($LANG as $key => $value) {
				if(!defined($key)) define($key,$value);
			}
		}
	}
	
	*/
	
	# add table from external plugin
	private  function addons_table_plugins($datas) {
		//echo ("this->mode= ".$this->getMode());
		if ($this->getMode() !="builder"){
			$plxMotor = plxMotor::getInstance();
			$tmp = $plxMotor->plxPlugins->aPlugins;
			$data='';
			foreach($tmp as $key => $value) {
				// echo ("key=".$value->getParam("spxdatas_widget"));
				if ($value->getParam("spxdatas_widget")=="1"){
					$path = PLX_PLUGINS.$key.'/spxdatas/table/table.php';
					if(is_file($path)) {
						# Mise en place du parseur XML
						$data .= implode('',file($path));
					}
				}
			}
			$data.="</document>";
			$datas = str_replace ("</document>",$data,$datas);
			return $datas;
		}else{
			return $datas;
		}
	}
	
	# add more loc from external plugin
	private  function addons_loc_plugins($LANG,$mylang) {
		//echo ("this->mode= ".$this->getMode());
		if ($this->getMode() !="builder"){
			$plxMotor = plxMotor::getInstance();
			$tmp = $plxMotor->plxPlugins->aPlugins;
			foreach($tmp as $key => $value) {
				//echo ("key=".$key);
				if ($value->getParam("spxdatas_widget")=="1"){
					$tmp = $plxMotor->plxPlugins->aPlugins[$key];
					$LANGADD = $tmp->get_loc($mylang);
					/*echo ("<pre>");
					print_r($LANGADD);
					echo ("</pre>");*/
					$LANG = array_merge ($LANG,$LANGADD);
				}
			}
			return $LANG;
		}else{
			return $LANG;
		}
	}
	
}
?>